-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

-- 획득 알림 아이템목록
local AlertLootItemList={
    "질긴 옆구리살",
    "보랏빛 해파리",
    "무거운 반짝껍질",
    "호화로운 모피",
    -- 이하 퀘스트 관련
    "영혼의 정수",
    "피눈물 부족 혈액",
    "피눈물 횃불",
    "오염된 지옥멧돼지 고기",
    "지옥멧돼지 혈액 견본",
    "장막의 스키스 우리 열쇠",
    "파멸의 해골",
    "고대의 주화",
    "심해 명주",
--    "질긴 가죽",
--    "두꺼운 가죽",
--    "맑은 샘물",
--    "거대한 무턱 모래무지",
--    "거대한 화염 암모나이트",
--    "거대한 바다 전갈",
--    "거대한 검은바다 채찍꼬리",
--    "거대한 심연 풍선장어",
--    "거대한 눈먼 민물 철갑상어",
--  "단열 배선",
};

local AlertLootItem = CreateFrame("FRAME");
AlertLootItem:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

LJDAlertLootItemList = {}; -- 알림대상아이템LIST
LJDNewlyLootItemList = {}; -- 최근획득대상아이템LIST

-- 최근획득알림아이템의 획득이후 최소 표현 시간(초)
-- ; 획득후 180초간은 가방을 계속해서 열고 닫아도 최근획득으로 표현됨.
-- 20210820 설정으로 이동
--local LJDMinSecondNewlyLootItemDisplay = 120;

-- 아이템 아이콘 추가
local function LJDAddItemIcons(link, iconHeight)
    if( not iconHeight ) then 
        iconHeight = 12;
    end
    local texture = GetItemIcon(link);
    
    return "\124T" .. texture .. ":" .. iconHeight .. "\124t" .. link;
end


-- 아이템획득메시지 필터
local function LJDAlertLootItemFilter(self, event, msg, ...)

    -- 아이콘 추가
	msg = msg:gsub("(\124c%x+\124Hitem:.-\124h\124r)", LJDAddItemIcons);

    -- 주위타케릭 아이템 획득은 아이콘만 추가하고 끝냄.
    local unitGUID = select(11, ...);
    if( UnitGUID("player") ~= unitGUID ) then
        return false, msg, ...;
    end
    
    -- 이하 내케릭 아이템 획득처리
    
    -- 획득알림 대상List에 추가후 아이템 획득 메시지는 표현안함
    -- 가방에 들어올때(BAG_UPDATE_DELAYED) 갯수와 함께 표현함
    local itemString = string.match(msg, "item[%-?%d:]+");
    if( itemString ) then

        -- 퀘스트아이템 획득은 CHAT_MSG_LOOT 이벤트보다 먼저 받는다.
        -- 따라서, 퀘스트아이템 획득은 대상List에 담지 않도록 함.
        local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
          itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID,
          isCraftingReagent = GetItemInfo(itemString);

        -- 20210123 가방을 열었을때 최근획득아이템 표시 기능
        -- List에 담기
        local itemID = string.match(itemLink or "", "item:(%d+)");  -- 링크에서 ID 추출
        itemID = tonumber(itemID);

        -- 회색템 제외
        --if( itemRarity > 0 ) then
            table.insert(LJDNewlyLootItemList, {["getTime"]=GetTime(), ["itemID"]=itemID});
        --end
        
        --LJDNewlyLootItemList[GetTime()] = itemID;

        --DebugPrint({C_Item.GetItemInventoryTypeByID(itemString)});
        --DebugPrint({C_Item.IsItemDataCachedByID(itemString)});
        --DebugPrint(#LJDAlertLootItemList); -- 배열 아님으로 출력안됨
        
        --[[
        -- 무조건 대상List에 담도록 함. 20210112
        if( itemClassID == LE_ITEM_CLASS_QUESTITEM ) then
        
            --DebugPrint({GetItemInfo(itemString)});
            --DebugPrint("---------------------------------------");
            DebugPrint(itemName..":"..tostring(itemStackCount));
            -- 도전자의 공물 [도전자의 공물] 1 1 1 퀘스트 퀘스트 10 _ 132594 0 12 0 4 0 nil false
            -- 거트스                        1 1 1 퀘스트 퀘스트 1  _ 133731 0 12 0 4 0 nil false
            -- 요트나르                      1 1 1               1  _ 467781 0 12 0 4 0 nil false 
        
            -- 결론, 1개 짜리든, 50개 짜리든 중구난방
            -- 퀘스트는 획득으로 통일
            if( itemStackCount == 1 ) then
                -- 대상List에 담지 않고 바로 출력
                LJDAlertLootItemCount(msg);
                return true, msg, ...;
            end
        end
        --]]

        -- 아이템 담기 -> 현재시각:itemString
        LJDAlertLootItemList[GetTime()] = msg;
        -- 1.5 초뒤 획득알림(알림List에 남는 아이템 제거용)
        C_Timer.After(1.5, LJDAlertLootItemCountList);
        
        -- true 리턴시 메시지 필터됨(출력안함)
        return true, msg, ...;
    end
    
    return false, msg, ...;
    
end
ChatFrame_AddMessageEventFilter("CHAT_MSG_LOOT", LJDAlertLootItemFilter);

function AlertLootItem:BAG_UPDATE_DELAYED(...)
    local ll = {...};
    --DebugPrint(ll);
    --DebugPrint(LJDNewlyLootItemList);
    --DebugPrintTable(LJDNewlyLootItemList);
    --DebugPrint(LJDAlertLootItemList);
    --DebugPrintTable(LJDAlertLootItemList);
    
    --DebugPrint(table.count(LJDNewlyLootItemList));
    --DebugPrint(table.count(LJDAlertLootItemList));
    --DebugPrint(metatable(LJDNewlyLootItemList).__len)
    
    --DebugPrint(table.rawlen(LJDNewlyLootItemList));
    
    --DebugPrint(table.rawlen(LJDAlertLootItemList));
    
    LJDAlertLootItemCountList();
end
AlertLootItem:RegisterEvent("BAG_UPDATE_DELAYED");

--[[
function AlertLootItem:QUEST_WATCH_UPDATE(...)
    local ll = {...};
    --DebugPrint(ll);
    
    LJDAlertLootItemCountList();
    
end
--AlertLootItem:RegisterEvent("QUEST_WATCH_UPDATE");

function AlertLootItem:BAG_UPDATE(...)
    local ll = {...};
    --DebugPrint(ll);

    LJDAlertLootItemCountList();

end
--AlertLootItem:RegisterEvent("BAG_UPDATE");

function AlertLootItem:UNIT_INVENTORY_CHANGED(...)
    local ll = {...};
    --DebugPrint(ll);

    LJDAlertLootItemCountList();

end
--AlertLootItem:RegisterEvent("UNIT_INVENTORY_CHANGED");

function AlertLootItem:BAG_NEW_ITEMS_UPDATED(...)
    local ll = {...};
    --DebugPrint(ll);
    
    LJDAlertLootItemCountList();
    
end
--AlertLootItem:RegisterEvent("BAG_NEW_ITEMS_UPDATED");

function AlertLootItem:ITEM_PUSH(...)
    local ll = {...};
    --DebugPrint(ll);
    
    LJDAlertLootItemCountList();
    
end
--AlertLootItem:RegisterEvent("ITEM_PUSH");

function AlertLootItem:BAG_SLOT_FLAGS_UPDATED(...)
    local ll = {...};
    --DebugPrint(ll);
    
    --LJDAlertLootItemCountList();
    
end
--AlertLootItem:RegisterEvent("BAG_SLOT_FLAGS_UPDATED");

function AlertLootItem:QUEST_LOOT_RECEIVED(...)
    local ll = {...};
    --DebugPrint(ll);
    
    LJDAlertLootItemCountList();
    
end
--AlertLootItem:RegisterEvent("QUEST_LOOT_RECEIVED");

function AlertLootItem:QUEST_WATCH_UPDATE(...)
    local ll = {...};
    --DebugPrint(ll);
    
    LJDAlertLootItemCountList();
    
end
AlertLootItem:RegisterEvent("QUEST_WATCH_UPDATE");

function AlertLootItem:UI_INFO_MESSAGE(...)
    local ll = {...};
    --DebugPrint(ll);
    
    LJDAlertLootItemCountList();
    
end
--AlertLootItem:RegisterEvent(UI_INFO_MESSAGE);
--]]
--[[
function LJDIsNewItem(itemLink)
	for i = 0, NUM_BAG_SLOTS do
		for j = 1, GetContainerNumSlots(i) do
			local _, itemCount, _, quality, _, _, link = GetContainerItemInfo(i, j);
            local id = GetContainerItemID(i, j);
            --DebugPrint(link);
            --DebugPrint(id);
			if(link == itemLink) then
                DebugPrint(link..":"..itemCount);
				
                if( C_NewItems.IsNewItem(i, j) ) then
                    return i, j;
                end
                
			end
		end
	end
	return -1, -1;
end
--]]


-- 알림대상아이템LIST에 있는 모든 아이템 획득알림 표현
function LJDAlertLootItemCountList()
    for k,v in pairs(LJDAlertLootItemList) do
        --DebugPrint(v);
        --[[
        local itemString = string.match(v, "item[%-?%d:]+");
        if( not itemString ) then
            return;
        end
        
        local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
          itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID,
          isCraftingReagent = GetItemInfo(itemString);
        
        --DebugPrint(itemLink);
        LJDIsNewItem(itemLink);
        --DebugPrint({LJDIsNewItem(itemLink)});
        --]]
        LJDAlertLootItemCount(v);
        LJDAlertLootItemList[k] = nil;
    end
end

-- 보유갯수 알림
function LJDAlertLootItemCount(msg)

    local itemString = string.match(msg, "item[%-?%d:]+");
    if( not itemString ) then
        return;
    end

    local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
          itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID,
          isCraftingReagent = GetItemInfo(itemString);

    --------------------------------------------------------------------------------
    -- 모든 아이템 획득시마다 항상 보유갯수 출력기능
    --------------------------------------------------------------------------------
    local bCnt = GetItemCount(itemLink, false);   -- 은행미포함.(2번째 인자)
    local lootItemCount = string.match(msg, "x(%d+)") or 1;
    local tCnt = bCnt;  -- 현재 입수된 아이템 갯수 제외

    local lootItemCountText = "";
    if( lootItemCount == 1 ) then
        lootItemCountText = "";
    else
        lootItemCountText = "x"..tostring(lootItemCount);
    end
    
    -- 보유갯수 카운팅이 안되는 경우 현재 획득갯수로 대체
    -- 퀘스트아이템 등
    local bNotCountedItem = false;  -- 카운팅 안되는 아이템여부(퀘스트아이템 등)
    if( tCnt == 0 ) then
        bNotCountedItem = true;
        tCnt = lootItemCount;
    end
    
    local formatedString = format(L["%s |cffffffff%s개|r 보유"],msg, tCnt);
    local formatedString_UIError = format(L["%s%s |cffffffff%s개|r 보유"], LJDAddItemIcons(itemLink,15), lootItemCountText, tCnt);
    --local formatedString_UIError = format(L["%s |cffffffff%s개|r 보유"], LJDAddItemIcons(itemLink,15), tCnt);
    --local formatedString_UIError = format(L["%s |cffffffff%s개|r 보유"],msg, tCnt);

    -- 카운팅 안되는 아이템 획득으로 표현
    if( bNotCountedItem ) then
        formatedString = format(L["%s |cffffffff%s개|r 획득"],msg, tCnt);
        formatedString_UIError = format(L["%s%s |cffffffff%s개|r 획득"], LJDAddItemIcons(itemLink,15), lootItemCountText, tCnt);
        --formatedString_UIError = format(L["%s |cffffffff%s개|r 획득"], LJDAddItemIcons(itemLink,15), tCnt);
        --formatedString_UIError = format(L["%s |cffffffff%s개|r 획득"],msg, tCnt);
    end

    --------------------------------------------------------------------------------
    -- 찾는 아이템인지 확인
    --------------------------------------------------------------------------------
    local CheckInList = false;
    --local itemID = "";
    for i=1, #AlertLootItemList do
        if itemName == AlertLootItemList[i] then
            CheckInList = true;
            break;
        end;
    end

    --------------------------------------------------------------------------------
    -- 획득 알림.
    --------------------------------------------------------------------------------
    if CheckInList then
        --PlaySound_LootItem();
        PlaySound_Success();
        formatedString = "|cffff0000"..formatedString.." ".."|r";
        formatedString_UIError = "|cffff0000\<"..L["아이템획득"].."\> "..formatedString_UIError.."|r";
        --formatedString_UIError = "|cffff0000"..formatedString_UIError.." ".."|r";
    end


--[[    
    --local info = ChatTypeInfo["LOOT"];
	--DEFAULT_CHAT_FRAME:AddMessage(formatedString, 0, 1, 0, info.id);  -- Green
    --DebugPrint(DEFAULT_CHAT_FRAME.zoneChannelList);
    --DebugPrint(NUM_CHAT_WINDOWS);
    --DebugPrint(CHAT_FRAMES);
    --DebugPrint(FCF_GetNextOpenChatWindowIndex());
    --DebugPrint(C_ChatInfo.GetNumReservedChatWindows());
    --DebugPrint(FCF_GetNumActiveChatFrames());

ChatConfigOtherSettingsCombat
ChatConfigFrame.lua

function IsListeningForMessageType(messageType)
	local messageTypeList = FCF_GetCurrentChatFrame().messageTypeList;
	for index, value in pairs(messageTypeList) do
		if ( value == messageType ) then
			return true;
		end
	end
	return false;
end

	[5] = {
 		text = ITEM_LOOT,
 		type = "LOOT",
 		checked = function () return IsListeningForMessageType("LOOT"); end;
 		func = function (self, checked) ToggleChatMessageGroup(checked, "LOOT"); end;
 	},
]]--

    -- 아이템획득메시지
    --DEFAULT_CHAT_FRAME:AddMessage(formatedString, 0, 1, 0);  -- Green
    
    -- 20220804 
    -- 채팅창을 여러개로 나두고, 채팅창별로 아이템획득메시지 표시 여부를 설정한 경우를 감안하여
    -- 채팅창의 필터 설정을 준용하기 위한 처리
    -- ; 아이템획득메시지 설정한 모든 채팅창에 메시지 출력
    for i = 1, NUM_CHAT_WINDOWS do
        local chatFrame = _G["ChatFrame"..i];
        if(chatFrame) then
            --DebugPrint(chatFrame);
            --DebugPrint(chatFrame.messageTypeList);
            if( IsChatFrameListeningForMessageType(chatFrame, "LOOT") ) then
                chatFrame:AddMessage(formatedString, 0, 1, 0);  -- Green
            end
        end
	end
    
    -- 회색템 제외
    if( itemRarity > 0 ) then
        
        --if( itemClassID == LE_ITEM_CLASS_QUESTITEM and itemStackCount > 1 ) then
            -- 퀘스트 아이템 알림안함
        if( bNotCountedItem ) then
            -- 카운팅 안되는 아이템은 중앙알림안함
        else
            -- 에러프레임(화면중앙)
            UIErrorsFrame     :AddMessage(formatedString_UIError, 0, 1, 0);  -- Green
        end
    end
end

function IsChatFrameListeningForMessageType(chatFrame, messageType)
    if( chatFrame == nil ) then
        return false;
    end
	local messageTypeList = chatFrame.messageTypeList;
	for index, value in pairs(messageTypeList) do
		if ( value == messageType ) then
			return true;
		end
	end
	return false;
end

--[[
function AlertLootItem:CHAT_MSG_LOOT(...)
    local ll = {...};
    --DebugPrint(ll);

    local event, msg = ...;
    --DebugPrint(msg);

    -- 20191124
    -- 내케릭 아이템 획득만 처리
    -- 요거 안하면 주위타케릭 아이템 획득도 알림.
    local unitGUID = select(13, ...);
    if( UnitGUID("player") ~= unitGUID ) then
        return;
    end
    --------------------------------------------------------------------------------
    -- 1단계)
    -- 아이템획득 채팅창의 메시지내용을 이용하여, 아이템링크에서 itemString 추출
    -- ex) 아이템을 획득했습니다. : [질긴 옆구리살]x5
    --  itemString    ==> item:3299::::::::20:257::::::
    --  lootItemCount ==> 5
    --
    -- 참고) ItemLink 형태
    --  ==> |cff9d9d9d|Hitem:3299::::::::20:257::::::|h[Fractured Canine]|h|r
    --------------------------------------------------------------------------------
    --local msg ="|cff9d9d9d|Hitem:3299::::::::20:257::::::|h[Fractured Canine]|h|r"
    local itemString = string.match(msg, "item[%-?%d:]+");
    local lootItemCount = string.match(msg, "x(%d+)") or 1;
    --DebugPrint(itemString);
    --DebugPrint(lootItemCount);
    
    if( not itemString ) then
        return;
    end
    
    --------------------------------------------------------------------------------
    -- 위에서 사용한 정규식 설명
    -- 1. string.match(msg, "item[%-?%d:]+");
    -- [set]: 중괄호 안의 어떤 문자라도 맞으면 OK.(모두 or) 
    -- %-   : %x는 예약어 기능 없이 문자열 자체를 사용하겠단 의미.[예약어 ^$()%.[]*+-?]
    --        - 는 [앞문자 기준](없을수도 있고)최소 반복될때 까지 찾는 예약어(*,+,-,?),
    --        여기선 앞에 %을 붙여서 예약어가 아닌 "-" 문자를 의미.
    -- ?    : ?는 [앞문자 기준](없을수도 있고) 많이 있어도 한번만 찾는 예약어.
    --        앞문자는 "-", - 를 사용해도 같은 결과일듯, %--
    -- %d   : 숫자를 의미
    -- :    : 예약어 아님, 문자 ":"
    -- +    : + 는 [앞문자 기준](없을수도 있고)최대 반복될때 까지 찾는 예약어(*,+,-,?),
    --        여기선 앞문자가 [set]이므로, set에 포함되는 않는 문자열이 나올때까지
    --        계속해서 길어질거란 의미.
    -- 
    -- 정리) "item" + ( "-" 또는 숫자 또는 ":" )..포함되는 않는 문자열이 나올때까지.
    --       위의 예문에서 |(파이프)는 포함되지 않으니깐, 
    --       결과는 : "item:3299::::::::20:257::::::"
    -- 
    -- 진득의견) 그냥 -는 버리고, "item[%d:]+" 하면 안되나... 못찾는건 버려도 되니..
    -- 
    -- 2. string.match(msg, "x(%d+)") or 1
    -- x    : "x"
    -- %d+  : 숫자만 이어진 문자열
    -- ()   : 괄호안의 부분만 반환하겠단 의미, 괄호가 여러번 있으면 v1,v2,v3..형태반환
    --        여기선 괄호가 한개만 있으므로 반환값은 1개임.
    -- 정리) "x"+숫자 부분에서 숫자만 추출하겠단 의미.
    --       or 1 : nil이면 1반환.
    --
    -- etc.
    -- link:match('item:(%d+)')    =>   item: 이후 첫번째 숫자부분만 반환.(itemId)
    -- 
    --------------------------------------------------------------------------------

    --------------------------------------------------------------------------------
    -- 2단계)
    -- 아이템정보 조회
    -- GetItemInfo(itemString) 이용
    --------------------------------------------------------------------------------
    --local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
    --      itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID,
    --      isCraftingReagent = GetItemInfo(itemID or "itemString" or "itemName" or "itemLink")
    
    --DebugPrint({GetItemInfo(itemString)});

    local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount,
          itemEquipLoc, itemIcon, itemSellPrice, itemClassID, itemSubClassID, bindType, expacID, itemSetID,
          isCraftingReagent = GetItemInfo(itemString);

    --------------------------------------------------------------------------------
    -- 20191123 모든 아이템 획득시마다 항상 보유갯수 출력기능 추가
    -- 챗창이 지저분해지는걸 피하기 위해 에러프레임만 출력함.
    --------------------------------------------------------------------------------
    local bCnt = GetItemCount(itemLink, nil,true);   -- 은행미포함.(2번째 인자)
    local lCnt = lootItemCount;
    local tCnt = bCnt + lootItemCount;

    local formatedString = format(L["%s %s개 보유"],itemLink, tCnt);

    --------------------------------------------
    -- 20191125 회색템이상 알림토록 함.
    --------------------------------------------
    if( itemRarity > 0 ) then
        --DebugPrint({GetItemInfo(itemString)});
        --print( "보유:"..bCnt..",획득:"..lCnt.." 전체:"..tCnt);

        -------------------------------------------------------------
        -- 1차수정,
        -- 퀘스트아이템은 가방에 누적되지 않음.
        -- Ex) 20개 획득 퀘스트인경우 계속 1개로 표현됨.
        -- "획득" 으로 알림메시지 변경
        -- 2차수정.
        -- 퀘스트아이템 중에서도 누적되는 아이템이 있었음.
        -- 퀘스트아이템 "획득"표현 안함.(걍 1개 표현함.)
        -- 3차수정(20200205)
        -- 퀘스트아이템인 경우 기본UI의 퀘스트진행상황에 갯수가 
        -- 표현됨으로 알림표현 안함.
        -- 4차수정(20201219)
        -- 퀘스트아이템도 누적되는 아이템은 보유갯수 표현함.
        -------------------------------------------------------------
        --if( itemType == "퀘스트" and itemStackCount == 1 ) then
        if( itemClassID == LE_ITEM_CLASS_QUESTITEM and itemStackCount > 1 ) then
            --UIErrorsFrame     :AddMessage(""..itemLink.." "..tCnt.."|r개 획득", 0, 1, 0);    -- Green
            --DEFAULT_CHAT_FRAME:AddMessage(""..itemLink.." "..tCnt.."|r개 획득", 0, 1, 0);    -- Green
            UIErrorsFrame     :AddMessage(formatedString, 0, 1, 0);  -- Green
            DEFAULT_CHAT_FRAME:AddMessage(formatedString, 0, 1, 0);  -- Green
        else
            UIErrorsFrame     :AddMessage(formatedString, 0, 1, 0);  -- Green
            DEFAULT_CHAT_FRAME:AddMessage(formatedString, 0, 1, 0);  -- Green
        end

    end

    --------------------------------------------------------------------------------
    -- 3단계)
    -- 찾는 아이템인지 확인
    --------------------------------------------------------------------------------
    local CheckInList = false;
    --local itemID = "";
    for i=1, #AlertLootItemList do
        if itemName == AlertLootItemList[i] then
            CheckInList = true;
            break;
        end;
    end

    --------------------------------------------------------------------------------
    -- 4단계)
    -- 획득 알림.
    --------------------------------------------------------------------------------
    if CheckInList then
        --PlaySound_LootItem();
        PlaySound_Success();
        DEFAULT_CHAT_FRAME:AddMessage("\<"..L["아이템획득"].."\> "..formatedString, 1, 0, 0);    -- Red
    end

end
--AlertLootItem:RegisterEvent("CHAT_MSG_LOOT");


function AlertLootItem:BAG_NEW_ITEMS_UPDATED(...)
    local ll = {...};
    DebugPrint(ll);
end
--AlertLootItem:RegisterEvent("BAG_NEW_ITEMS_UPDATED");

function AlertLootItem:BAG_UPDATE(...)
    local ll = {...};
    DebugPrint(ll);
end
--AlertLootItem:RegisterEvent("BAG_UPDATE");


function AlertLootItem:UNIT_INVENTORY_CHANGED(...)
    local ll = {...};
    DebugPrint(ll);
end
--AlertLootItem:RegisterEvent("UNIT_INVENTORY_CHANGED");


function AlertLootItem:BAG_UPDATE_COOLDOWN(...)
    local ll = {...};
    DebugPrint(ll);
end
--AlertLootItem:RegisterEvent("BAG_UPDATE_COOLDOWN");

function AlertLootItem:BAG_UPDATE_DELAYED(...)
    local ll = {...};
    DebugPrint(ll);
end
--AlertLootItem:RegisterEvent("BAG_UPDATE_DELAYED");

function AlertLootItem:ITEM_PUSH(...)
    local ll = {...};
    DebugPrint(ll);
    
end
--AlertLootItem:RegisterEvent("ITEM_PUSH");
--]]

--[[
    EventRegistry:RegisterCallback("ContainerFrame.OpenBag", AlertLootItem.OpenBag)   ;   -- 동작함
    EventRegistry:RegisterCallback("ContainerFrame.OpenBag", on_ContainerFrame_OnShow);   -- 동작안함
    
    자세히는 잘 모르겠음.. 파악 필요..
    RegisterCallback에 의해 호출될때, 받아줄 객체와 넘겨준 객체를 구분하는 .. self 처럼 지칭하는 
    중간 객체가 반드시 필요한듯 추측만 됨.
]]--
function AlertLootItem:OpenBag(BagFrame, ...)
    local ll = {...};
    --DebugPrint("Open");
    --DebugPrintTable(ll);
    --DebugPrint(BagFrame:GetBagID());
    
    on_ContainerFrame_OnShow(BagFrame);
    
end
--EventRegistry:RegisterCallback("ContainerFrame.OpenBag", AlertLootItem.OpenBag, self);
EventRegistry:RegisterCallback("ContainerFrame.OpenBag", AlertLootItem.OpenBag);

function AlertLootItem:CloseBag(BagFrame, ...)
    local ll = {...};
    --DebugPrint("Close");
    --DebugPrint(BagFrame:GetBagID());
    
    on_ContainerFrame_OnHide(BagFrame);
    
end
--EventRegistry:RegisterCallback("ContainerFrame.CloseBag", AlertLootItem.CloseBag, self);
EventRegistry:RegisterCallback("ContainerFrame.CloseBag", AlertLootItem.CloseBag);

-- 가방열었을때, 아이템 링크창의 아이콘을 깜박임 표시한다.
-- ;금방 습득한 아이템을 채팅창의 링크를 클릭했을때, 가방의 어디에 있는지 쉽게 찾기 기능.
function on_ContainerFrame_OnShow(self)

    --DebugPrintTable(self);
    --DebugPrint(self:GetBagID());
    --DebugPrint(self:IsCombinedBagContainer());
    
    -- 1초마다 재귀호출
    if not self.LJDGameTooltipTicker then
        self.LJDGameTooltipTicker = C_Timer.NewTicker(0.5, function() on_ContainerFrame_OnShow(self) end );
    end

    --DebugPrint(self:GetName());
    local tarItemName, tarItemLink = GameTooltip:GetItem();
    local refItemName, refItemLink = ItemRefTooltip:GetItem();
    
    -- 우선순위 : 아이템링크 1순위
    if( refItemLink ) then
        tarItemLink = refItemLink;
    end

    --print(tarItemLink);
    -- 아이템정보 없으면 패쓰
    if( not tarItemLink ) then
        -- 디버그용
        --tarItemLink   = "|cffffffff|Hitem:6948::::::::20:66::75:::::::|h[귀환석]|h|r"
        --tarItemLink = "|cffffffff|Hitem:6948::::::::120:66::::::|h[귀환석]|h|r";
        --tarItemLink = "|cffffffff|Hitem:158379::::::::120:66::13:1:3524:::|h[불안정한 시간 변형기]|h|r";

        if( #LJDNewlyLootItemList == 0 ) then
            --DebugPrintLink("Empty List");
            return;
        end
    end
    
    -- 20210821 표시설정에 따라 표현
    if not LJDSpellInterruptDB["ShowNewlyLootItem"] then
        return;
    end
    
    -- 링크 복사용
    --DebugPrintLinkError(tarItemLink);

    local tarItemID = string.match(tarItemLink or "", "item:(%d+)");  -- 링크에서 ID 추출
    tarItemID = tonumber(tarItemID);
    --DebugPrint(tarItemID);
    
    --[[
    for bag = 0, NUM_BAG_SLOTS, 1 do
		local numBagSlots = ContainerFrame_GetContainerNumSlots(bag);
        
        --DebugPrint( bag .. ":" .. numBagSlots);
        
		for i = 1, numBagSlots do
			local containerFrame = UIParent.ContainerFrames[bag + 1];
			local itemButton = containerFrame.Items[i];
			local slot = numBagSlots - i + 1;

			--DebugPrintTable(itemButton);
		end
	end
    ]]--

    --local bagID = self:GetBagID();

    -- 20221105 10.0.0 가방합치기 기능에 의해 모든 가방에서 확인하도록 변경
    -- 모든 가방 확인할때 for(여기서는 가방마다 함수가 호출되므로 필요없음)
    for bagID = 0, NUM_BAG_SLOTS do

        -- 모든 슬롯
        local numBagSlots = ContainerFrame_GetContainerNumSlots(bagID);
        for i = 1, numBagSlots do
            local slot = numBagSlots - i + 1;
            --print(bagID, slot);
            -------------------------------------------------------------
            -- 특이점
            -- 버튼의 GetID() 와 ButtonName index, slot는 일치하지 않음
            -- ContainerFrame.lua를 참조하여
            -- 버튼의 GetID() 이용함.
            -------------------------------------------------------------
            
            -------------------------------------------------------------
            -- 20221106
            -- 10.0.0
            -- ContainerFrameCombinedBags : 가방합쳤을때 Frame 이름
            -- ContainerFrame1 ~5         ; 개별가방의 Frame 이름
            -- Ex) 첫번째 가방의 1번째 아이템인 경우
            --          ContainerFrame1Item1
            -- self:IsCombinedBagContainer() : 가방합치기 여부
            -------------------------------------------------------------
            --local itemButtonName = (self:GetName()).."Item"..slot;
            local itemButtonName = "ContainerFrame"..(bagID+1).."Item"..slot
            
            local itemButton = _G[itemButtonName];
            --local itemButton = self.Items[i];
            --DebugPrint(itemButtonName);

            if( not itemButton ) then
                --local containerFrame = UIParent.ContainerFrames[bag + 1];
                --local itemButton = containerFrame.Items[i];   
                DebugPrint("itemButton Not found.");
                return;
            end
    --DebugPrint(itemButton:GetID());
            -- 각 가방의 슬롯, 아이템 확인
            --local icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID = GetContainerItemInfo(bagID, itemButton:GetID());
            -- 20221119 10.0.2 대응
            --local icon, itemCount, locked, quality, readable, lootable, itemLink, isFiltered, noValue, itemID
            local containerInfo = C_Container.GetContainerItemInfo(bagID, itemButton:GetID());
            local itemID = containerInfo and containerInfo.itemID; -- containerInfo 결과값이 nil 일수 있으므로
            --print(itemButtonName, itemLink, bagID, slot, itemButton:GetID());
            --DebugPrintTable(containerInfo);

            --DebugPrintLink(tarItemLink);
            --DebugPrintLink(itemLink);
            
            if( itemButton.flashAnim:IsPlaying() or itemButton.newitemglowAnim:IsPlaying()) then
                itemButton.flashAnim:Stop();
                itemButton.newitemglowAnim:Stop();
            end
            
            -- 링크아이템이 있거나, 마우스오버가 있으면 우선 표현됨
            if( tarItemLink ) then
                -- 아이템링크와 같은 아이템이면 눈에 띄게 표현
                if( tarItemID and tarItemID == itemID ) then
                    --print(tarItemID, itemID);
                    --DebugPrint("아이템 발견");
                    --DebugPrint(bagID);
                    --DebugPrint(slot);
                    --DebugPrint(GameTooltip:IsOwned(itemButton));
                    --DebugPrint(itemButton.flashAnim:IsPlaying());
                    --DebugPrint(itemButton.newitemglowAnim:IsPlaying());
                    --DebugPrint("");
                    
                    -- 아이템위에 마우스를 올린 경우 깜박임 처리 안함
                    if ( not GameTooltip:IsOwned(itemButton) ) then
                        if (not itemButton.flashAnim:IsPlaying() and not itemButton.newitemglowAnim:IsPlaying()) then
                        
                            --DebugPrint(bagID);
                            --DebugPrint(slot);
                        
                            itemButton.flashAnim:Play();
                            itemButton.newitemglowAnim:Play();
                        end
                    end
                    
                    --[[
                    local btnTexture = itemButton.Icon or itemButton.icon or _G[itemButton:GetName().."IconTexture"];
                    local btnColR, btnColG, btnColB, btnColA = btnTexture:GetVertexColor();

                    -- 1 으로 설정해도 1 보다 모자르다. ex) 0.99999779462814
                    if( btnColR > 0.9999 ) then btnColR = 1 end;
                    if( btnColG > 0.9999 ) then btnColG = 1 end;
                    if( btnColB > 0.9999 ) then btnColB = 1 end;
                    if( btnColA > 0.9999 ) then btnColA = 1 end;

                    --SetItemButtonTextureVertexColor(itemButton, 1,0,0);
                    if( btnColR == 1 and btnColG == 0 and btnColB == 0 ) then
                        --btnTexture:SetVertexColor(1, 1, 1);
                    else
                        --btnTexture:SetVertexColor(1, 0, 0);
                    end
                    
                    --itemButton.IconBorder:SetVertexColor(1, 0, 0);
                    --]]
                end
            -- 링크아이템이 없거나, 마우스오버 아이템이 없을때만 최근획득아이템 표시
            else
                -- 20210123 가방을 열었을때 최근획득아이템 표시 기능
                --DebugPrint(LJDNewlyLootItemList);
                for k,v in pairs(LJDNewlyLootItemList) do
                    if( v.itemID == itemID ) then
                        -- 아이템위에 마우스를 올린 경우 깜박임 처리 안함
                        if ( not GameTooltip:IsOwned(itemButton) ) then
                            if (not itemButton.flashAnim:IsPlaying() and not itemButton.newitemglowAnim:IsPlaying()) then
                                itemButton.flashAnim:Play();
                                itemButton.newitemglowAnim:Play();
                            end
                        end
                    end
                end
            end
        end
    end
end
--hooksecurefunc("ContainerFrame_OnShow", on_ContainerFrame_OnShow);

function on_ContainerFrame_OnHide(self)
    --print("Hide");
    -- 타이머 중지 및 제거
    if self.LJDGameTooltipTicker then
        self.LJDGameTooltipTicker:Cancel();
        self.LJDGameTooltipTicker = nil;
    end

    --LJDNewlyLootItemList = {}; -- 최근획득대상아이템LIST 초기화
    -- 최소표현시간을 넘긴 아이템만 최근획득아이템 목록에서 제거
    for k,v in pairs(LJDNewlyLootItemList) do
        -- 20210820 기준시간 설정기능추가
        --if( (v.getTime + LJDMinSecondNewlyLootItemDisplay ) < GetTime() ) then
        if( (v.getTime + LJDSpellInterruptDB["SecondShowNewlyLootItemMinDuration"] ) < GetTime() ) then
            --DebugPrintTable(v);
            table.remove(LJDNewlyLootItemList, k);
        end
    end
end
--hooksecurefunc("ContainerFrame_OnHide", on_ContainerFrame_OnHide);


