-----------------------------------------------------
-- lua 파일이 여러개인 경우
-- 애드온명, 애드온내공유테이블이 ...으로 전달됨
-----------------------------------------------------
local addonName, L = ...;

local ShowBigBuffSkilIDList={
};
-- 크게 표현할 아이콘목록
local ShowBigBuffSkilList={
    "고위 천사",
    "불안정한 마나진주",
    "정의의 방패",
    "빛의 보루",
    "울려퍼지는 보호",
    "무의 보호막",
    "강화된 무의 보호막",
    "나가 가죽",
    "얼음 보호막",
    "오색 방벽",
    "신비의 마법 강화",
    "악마 쐐기",
    "악마의 영혼: 불행",
    "고통 감내",
    "방패 올리기",
    "무쇠가죽",
    "거북의 상",
    "죽은 척하기",
--    "승리",
};

local MOUSEOVER = {};   -- 마우스오버 하일라이트

local LJDNameplate = CreateFrame("FRAME");
LJDNameplate:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function LJDNameplate:PLAYER_ENTERING_WORLD()
    -- 내케릭용 큰버프 아이콘 표시프레임 생성
    createPlayerBigBuffFrame();
    PlayerBigBuffFrame_Update();
    LJDNameplate_StartTimer();  -- onupdate 대체용 타이머
end
LJDNameplate:RegisterEvent('PLAYER_ENTERING_WORLD');

function LJDNameplate:UNIT_AURA(...)
    local event, unitid = ...

    --if unitid ~= "player" then return end
    PlayerBigBuffFrame_Update();  -- 내케릭전용 버프(큰아이콘)

    --print(event..":"..unitid);
    local plateFrame = C_NamePlate.GetNamePlateForUnit(unitid);
    if (not plateFrame) then
        return
    end
    LJDNameplate_Aura_update(plateFrame.UnitFrame);

end
LJDNameplate:RegisterEvent("UNIT_AURA");

function LJDNameplate:NAME_PLATE_CREATED(...)
    local ll = {...};
    --DebugPrintTable(ll);

    local plateFrame = ll[2];
    --DebugPrintTable(ll[2]);

    -- 20201018
    -- NAME_PLATE_CREATED 이벤트에서 UnitFrame 이벤트가 발생하지 않음. NAME_PLATE_UNIT_ADDED 이동하게 됨.
    if( not plateFrame.UnitFrame ) then
        return;
    end
    
    --> 마우스오버 하일라이트
    --MOUSEOVER.CreateHighlightNameplate (plateFrame);

    --> 버프/디버프 표현
    --createHighlightBuffFrame(plateFrame);
    --createHighlightDeBuffFrame(plateFrame);
end
LJDNameplate:RegisterEvent("NAME_PLATE_CREATED");

function LJDNameplate:NAME_PLATE_UNIT_ADDED(...)
    local ll = {...};
    --DebugPrint(ll);
    local unitBarId = ll[2];
    local unitID = unitBarId

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitBarId, issecure());
    if (not plateFrame) then
        return;
    end

    local unitFrame = plateFrame.UnitFrame;
    ----------------------------------------------------------------------
    -- 201191220 큰이름표 설정 변경시 오류 관련 수정
    -- 아래가 문제였다.
    -- UnitFrame의 변수를 바꾸는 것이 오염된 코드라고 판단되는듯 하다.
    -- GetPoint, GetLeft 등에서 오류를 발생시킨다.
    -- 특이점, plateFrame는 가능했다.
    -- 
    --unitFrame.unit = unitID;
    --unitFrame ["namePlateUnitToken"] = unitID; -- 중요설정 : 이 값을 설정해야 오류 안남.(UnitIsUnit 등에서..)
    ----------------------------------------------------------------------

    -- 20201018
    -- NAME_PLATE_CREATED 이벤트에서 UnitFrame 이벤트가 발생하지 않음. NAME_PLATE_UNIT_ADDED 이동하게 됨.
    --> 마우스오버 하일라이트
    MOUSEOVER.CreateHighlightNameplate (plateFrame);

    --> 버프/디버프 표현
    createHighlightBuffFrame(plateFrame);
    createHighlightDeBuffFrame(plateFrame);


    --> 마우스오버 하일라이트
    if( unitFrame:IsShown() ) then
        MOUSEOVER.EnableHighlight (plateFrame); -- 인자를 unitFrame-> plateFrame 변경.
    end

    LJDNameplate_Aura_update(unitFrame);
    
    -- 이하 fstack 오류 수정 시도
    -- 실패
    
    --unitFrame:ClearAllPoints();
    --unitFrame:SetPoint("TOPLEFT", plateFrame, "TOPLEFT", 0, 0 );
    --unitFrame:SetPoint("BOTTOMRIGHT", plateFrame, "BOTTOMRIGHT", 0, 0 );
    --DebugPrint(unitFrame:GetPoint());
    --unitFrame:Hide();
    --[[
    unitFrame:ClearAllPoints();
    unitFrame:SetAllPoints(plateFrame);
    print(unitBarId);
    DebugPrintTable(unitFrame);
    DebugPrintTable(unitFrame.WidgetContainer);
    
    DebugPrint(unitFrame:GetPoint());
    
    --DebugPrint(unitFrame:GetNumPoints());
    local pointIndex = 1;
		while pointIndex <= unitFrame:GetNumPoints() do
            DebugPrint(pointIndex);
			local _, anchorFrame, anchorRelativePoint = unitFrame:GetPoint(pointIndex);
            DebugPrint(anchorFrame);
            DebugPrint(anchorRelativePoint);
            
			--AnchorHighlight(anchorFrame, self:RetrieveAnchorHighlight(pointIndex), anchorRelativePoint);
			pointIndex = pointIndex + 1;
		end
    --]]

end
LJDNameplate:RegisterEvent("NAME_PLATE_UNIT_ADDED");

function LJDNameplate:NAME_PLATE_UNIT_REMOVED(...)
    local ll = {...};
    local unitBarId = ll[2];

    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitBarId, issecure());

    --> 마우스오버 하일라이트
    MOUSEOVER.DisableHighlight (plateFrame.moHighlightFrame);

    --> 버프/디버프 표현
    removeHighlightFrame(plateFrame.highlightBuffFrame);
    removeHighlightFrame(plateFrame.highlightBigBuffFrame);
    removeHighlightFrame(plateFrame.highlightDeBuffFrame);
    removeHighlightFrame(plateFrame.highlightBigDeBuffFrame);

    --print("NAME_PLATE_UNIT_REMOVED : ["..UnitName(plateFrame.UnitFrame.displayedUnit).."]");
end
LJDNameplate:RegisterEvent("NAME_PLATE_UNIT_REMOVED");

-- OnUpdate 이벤트 대체용 타이머
function LJDNameplate_StartTimer()
    -------------------------------------------------------------------------
    -- 진득주 1)
    -- NewTicker 와 NewTimer에 관하여 .. 
    -- NewTicker는 세번째 인자 : 반복수(iterations)가 1인(한번) 
    -- NewTimer와 같다.
    -- (NewTicker의 기본값은 무한반복)
    -------------------------------------------------------------------------
    -- 진득주 2)
    -- Duration 이 0.001(1ms) 이하이면, 게임 클라이언트에 영향을 줄수 있다.
    -- 적어도, 60 FPS를 지켜 보려면, 60 FPS 가 0.016 s(f=1/t) 이므로, 
    -- 대강 0.01 보단 높게 설정하게 한다.
    -- 아래 math.max 가 그 역할용으로 최소값을 지정했다. 
    -------------------------------------------------------------------------
    local LJDTimerDuration = (LJDSpellInterruptDB["MilliSecondNameplateUpdateDoration"] or 150 ) / 1000;
	if not LJDNameplate.ticker then
		LJDNameplate.ticker = C_Timer.NewTicker(math.max(LJDTimerDuration, 0.01), function() LJDNameplate:onUpdate() end );   -- 60 프레임 지켜보려고..
	end
end

function LJDNameplate_StopTimer()
	if LJDNameplate.ticker then
		LJDNameplate.ticker:Cancel();
		LJDNameplate.ticker = nil;
	end
end

function LJDNameplate:onUpdate()

    -- 내케릭전용 버프(큰아이콘) 툴팁의 시간 갱신용
    for iconIndex=1,(PlayerBigBuffFrame.iconShownCount) do
        local icon = PlayerBigBuffFrame.icon[iconIndex];
        HighlightBuffFrame_AuraOnUpdate(icon);
    end

    -- 전체UnitFrame 갱신
    for _,baseFrame in pairs(C_NamePlate.GetNamePlates()) do
        --print(baseFrame.UnitFrame.unit);
        --print(baseFrame.highlightBuffFrame.iconShownCount);
        
        -- 전체 버프/디버프 재설정
        --LJDNameplate_Aura_update(baseFrame.UnitFrame);
        -- 어글변경 상태 재설정
        --LJDUpdateHealthBorder(baseFrame.UnitFrame);    -- 유닛별로 어글 표시해야 하므로 여기에 있음.
        
        -- 버프아이콘 상태(툴팁 시간등) 재설정
        for iconIndex=1,(baseFrame.highlightBuffFrame.iconShownCount) do
            local icon = baseFrame.highlightBuffFrame.icon[iconIndex];
            HighlightBuffFrame_AuraOnUpdate(icon);
        end
        -- BIG 버프아이콘 상태(툴팁 시간등) 재설정
        for iconIndex=1,(baseFrame.highlightBigBuffFrame.iconShownCount) do
            local icon = baseFrame.highlightBigBuffFrame.icon[iconIndex];
            HighlightBuffFrame_AuraOnUpdate(icon);
        end
        -- 디버프아이콘 상태(툴팁 시간등) 재설정
        for iconIndex=1,(baseFrame.highlightDeBuffFrame.iconShownCount) do
            local icon = baseFrame.highlightDeBuffFrame.icon[iconIndex];
            HighlightBuffFrame_AuraOnUpdate(icon);
        end
        -- BIG 디버프아이콘 상태(툴팁 시간등) 재설정
        for iconIndex=1,(baseFrame.highlightBigDeBuffFrame.iconShownCount) do
            local icon = baseFrame.highlightBigDeBuffFrame.icon[iconIndex];
            HighlightBuffFrame_AuraOnUpdate(icon);
        end
    end
end


function MOUSEOVER.CreateHighlightNameplate (plateFrame) --private

    -- 이미 있으면 생성안함.
    if( _G[plateFrame:GetName().."MoHighlightFrame"] ) then
        return;
    end

    --local moHighlightFrame = CreateFrame ("frame", nil, plateFrame)
    --local moHighlightFrame = CreateFrame ("frame", nil, UIParent);
    local moHighlightFrame = CreateFrame ("frame", "$parentMoHighlightFrame", UIParent)
    moHighlightFrame:Hide()
    --local moHighlightFrame = CreateFrame ("frame", "$parentMoHighlightFrame", plateFrame.UnitFrame)
    moHighlightFrame:EnableMouse (false)
    moHighlightFrame:SetFrameStrata ("TOOLTIP")
    moHighlightFrame:SetAllPoints (plateFrame.UnitFrame.healthBar)
    --moHighlightFrame:ClearAllPoints();


    --moHighlightFrame:SetPoint("LEFT",plateFrame.UnitFrame.healthBar,"RIGHT");
    --moHighlightFrame:SetSize(100,50);

    --moHighlightFrame:SetScript ("OnUpdate", MOUSEOVER.CheckHighlight)

    moHighlightFrame.HighlightTexture = moHighlightFrame:CreateTexture (nil, "overlay")
    moHighlightFrame.HighlightTexture:Hide()
    moHighlightFrame.HighlightTexture:SetAllPoints()
    moHighlightFrame.HighlightTexture:SetColorTexture (1, 1, 1, 1)  -- 흰색
    moHighlightFrame.HighlightTexture:SetAlpha (0.4)
    -- 메모리 누수
    --moHighlightFrame.UnitFrame = plateFrame.UnitFrame -- 이진득 : UnitFrame를 활용하기 위해 저장

    moHighlightFrame.userText = moHighlightFrame:CreateFontString (nil, "overlay", "NumberFontNormalSmall")
    moHighlightFrame.userText:SetJustifyH ("right")
    moHighlightFrame.userText:SetPoint ("center", 3, -2)

    --plateFrame.UnitFrame.HighlightFrame = moHighlightFrame
    plateFrame.moHighlightFrame = moHighlightFrame; -- 20191220 이름변경
end

function MOUSEOVER.CheckHighlight (self)
    ----------------------------------------
    -- 디버깅기능
    -- SavedVariables설정변수의
    -- ShowNameplateName 값이 true이면
    -- plate 이름 출력하기
    ----------------------------------------
    if LJDSpellInterruptDB["ShowNameplateName"] then
        self.userText:SetText(self.unit);
        self.userText:Show();
    else
        self.userText:Hide();
    end

    if (UnitIsUnit ("mouseover", self.unit)) then
        self.HighlightTexture:Show()

        --플레이어이면 표시 안함.
        if (UnitIsUnit("mouseover", "player")) then
            self.HighlightTexture:Hide();
        end;

    else
        self.HighlightTexture:Hide()
    end

end

function MOUSEOVER.EnableHighlight (plateFrame)
    plateFrame.moHighlightFrame:Show()
    plateFrame.moHighlightFrame.unit = plateFrame["namePlateUnitToken"]
    plateFrame.moHighlightFrame:SetScript ("OnUpdate", MOUSEOVER.CheckHighlight)
end

function MOUSEOVER.DisableHighlight (moHighlightFrame)
    moHighlightFrame:SetScript ("OnUpdate", nil)
    moHighlightFrame:Hide()
    moHighlightFrame.Shown = false
end

-- 버프를 우클릭하면 버프해제 처리
function HighlightBuffFrame_AuraOnMouseClick(self, ...)
    local ll = {...};
    --DebugPrintTable(ll);
    local button, down =  ...;

    if( not self.unitId ) then return end;

    if( button == "RightButton" ) then
        --버프 해제
        CancelUnitBuff(self.unitId, self:GetID(), self:GetParent().filter);
    end
end

--[[
------------------------------------------------
-- 직업별 해제 가능한 debuffType type
------------------------------------------------
드루이드 : Curse,          Poison, Magic(H)
마법사   : Curse
수도사   :        Disease, Poison, Magic(H)
성기사   :        Disease, Poison, Magic(H)
사제     :        Disease        , Magic
주술사   : Curse,                  Magic(H)
흑마     :                         Magic(임프) 

------------------------------------------------
-- 직업별 Magic 해제 가능한 스킬정보
-- ; 사제를 제외하고 모두 힐러의 해제스킬
------------------------------------------------
드루이드 : 88423  [자연의 치유력] 
마법사   : 
수도사   : 115450 [해독]
성기사   : 4987   [정화]
사제     : 527    [정화]
주술사   : 77130  [영혼 정화] 
흑마     :        임프스킬 정보 ....


전문화별이 아니라 직업별로 해제가능한지를 체크한 상황이고,
그중 Magic만은 힐러 고유 해제스킬으로만 해제가능함.
힐러의 해제스킬ID가 현재 플레이어의 스킬인지 체크함.
--]]
function IsDispelableMagicDebuff(debuffType)
    if debuffType ~= "Magic" then
        return true;
    end

    if debuffType == "Magic" then
        if(    ( IsPlayerSpell(88423)  )
            or ( IsPlayerSpell(115450) )
            or ( IsPlayerSpell(4987)   )
            or ( IsPlayerSpell(527)    ) 
            or ( IsPlayerSpell(77130)  ) ) then

            return true;
        else
            return false;
        end
    end
end

function HighlightBuffFrame_AuraOnUpdate(self, ...)
    local ll = {...};
    --DebugPrint("AuraOnUpdate:"..self.unitId);
    if( not self.unitId ) then return end;

    if ( GameTooltip:IsOwned(self) ) then
        GameTooltip:SetUnitAura(self.unitId, self:GetID(), self:GetParent().filter);
    end

    -- duration
    if( self.expirationTime and self.timeLeft > 0 ) then
        local duration = {"%s", ""};
        self.timeLeft = ceil(self.expirationTime - GetTime());  -- floor ( 0초 표현하지 않도록 수정 )

        if self.timeLeft > 0 then
            duration = {SecondsToTimeAbbrev(self.timeLeft)};
        end;

        self.duration:SetFormattedText(unpack(duration));
    end

    local parent = self:GetParent();
    if( parent.SpecialBuffMore ) and (parent.icon[parent.iconShownCount]) then
        parent.SpecialBuffMore:SetPoint("BOTTOMLEFT", parent.icon[parent.iconShownCount], "BOTTOMRIGHT", 1, 0 );
    end;

    -- 아이콘테두리색 지정
    if( not parent.isBuff ) then
        self.border:SetColorTexture(1,0,0,0.5); -- 디버프용 테두리 빨강
    else
        self.border:SetColorTexture(0,0,0,0);       -- 버프용 테두리 없음
    end

    -- 20201115 아군의 해제가능한 디버프 표시
    if( self.isDispellable and ( not parent.isBuff) ) then
        local reaction = UnitReaction("player", self.unitId);
        if reaction and reaction > 4 then
            
            -- 해제가능한 마법 디버프 재확인
            if IsDispelableMagicDebuff(self.isDispellable) then
                self.border:SetColorTexture(0,1,0,0.8); -- 해제가능하면 테두리 초록
            else
                self.isDispellable = nil; -- 마법해제 불가 재설정(HighlightBuffFrame_AuraOnUpdate 에서도 참조하도록)
            end
            
        end
    end

    if( self.isStealable == true ) then
        self.border:SetColorTexture(1,1,1,0.8); -- 마법훔치기가능 테두리 흰색(가장 우선순위 높음)
    end

end
function HighlightBuffFrame_AuraOnMouseEnter(self, ...)
    local ll = {...};

    --print(self.unitId, self:GetID(),  self:GetParent().filter);
    --DebugPrintTable(self);

    if( not self.unitId ) then return end;

    --GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT");
    GameTooltip:SetOwner(self, "ANCHOR_NONE");
    
    ---------------------------------------------------------------------
    -- 20191128
    -- 화면상단에서 툴팁이 화면밖으로 짤리는 현상해결을 위해
    -- 툴팁이 상단부에 있으면 툴팁을 아이콘 아래로 나타낸다.
    ---------------------------------------------------------------------
    local scale, x, y = UIParent:GetScale(), GetCursorPosition();
    local cursorX = x / scale;
    local cursorY = y / scale;
    local screenSizeX, screenSizeY = GetPhysicalScreenSize();
    local percentPosY = ((screenSizeY - cursorY) / screenSizeY) * 100;
    
    --print( percentPosY );
    ---------------------------------------------------------------------
    -- 툴팁을 화면상단에서부터 20%이내이면 아래로 표현, 그외 위에 표현
    ---------------------------------------------------------------------
    if( percentPosY < 20 ) then
        GameTooltip:SetPoint("TOPLEFT"   , self, "BOTTOMLEFT");
    else
        GameTooltip:SetPoint("BOTTOMLEFT", self, "TOPLEFT"   );
    end
    
    GameTooltip:SetFrameLevel(self:GetFrameLevel() + 2);

    if ( GameTooltip:IsOwned(self) ) then
        GameTooltip:SetUnitAura(self.unitId, self:GetID(), self:GetParent().filter);
    end

    --GameTooltip_SetDefaultAnchor( GameTooltip, UIParent );
  --GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
  --GameTooltip:SetText( "This text shows up when you mouse over\nthe MyFrame frame" )
  --GameTooltip:Show()
end
function HighlightBuffFrame_AuraOnMouseLeave(self, ...)
    --print("Leave");
    --DebugPrintTable(self);
    GameTooltip:Hide();
end

-- 오라 아이콘들 생성하고 가져오는 역할을 수행하는 함수
local function GetIcon(self , index)
    local icon = self.icon[index]; -- 처음에 만들었던 배열에서 아이콘을 가져온다.

    -- 만약 아이콘이 없으면 생성한다.
    if icon == nil then
        -- 아이콘 기본틀을 담당할 Frame 을 생성하고,
        --icon = CreateFrame("Frame", nil, self);
        icon = CreateFrame("Button", nil, self);
        icon:RegisterForClicks("AnyUp");    -- 클릭가능처리 20191114

        -- 아이콘 크기 지정
        icon:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]);
        -- 아이콘 위치를 정하는 IF 문
        if index == 1 then -- 첫번째 아이콘이면, 가장 처음 위치에 지정

            -- frame:SetPoint(point, relativeTo, relativePoint, x, y)
            -- point : 현재 frame 의 기준으로 위치 지정
            -- relativeTo : 정렬할 기준 프레임을 지정
            -- relativePoint : relativeTo 에 지정한 프레임의 어느쪽에 정렬할 것인가?
            -- (예를 들자면, relativeTo로 B 프레임을 지정했다면,
            -- B 프레임의 밑에 정렬할것인가? 오른쪽에 정렬할것인가? 선택)
            -- 아래 문장를 설명하자면,
            -- icon 프레임의 BOTTOMLEFT(하단좌측)모서리를, self 프레임의
            -- BOTTOMLEFT(하단좌측) 모서리 쪽에 정렬해두겠다
            icon:SetPoint("TOPLEFT", self, "TOPLEFT", 1, -1);   -- border 감안해서 1pixel씩 안으로 이동

        else -- 2번째 부터는 아이콘 오른쪽으로 한칸씩 정렬한다.
            -- icon 프레임의 LEFT(좌측)를, self 프레임의 RIGHT(우측)에 정렬.
            icon:SetPoint("LEFT", self.icon[index-1], "RIGHT", 1, 0);
        end

        -- icon 테두리 추가
        icon.border = icon:CreateTexture(nil, "BORDER");
        icon.border:SetSize(LJDSpellInterruptDB["ICON_WIDTH"]+2, LJDSpellInterruptDB["ICON_HEIGHT"]+2);
        icon.border:SetPoint("BOTTOMLEFT", icon, "BOTTOMLEFT", -1, -1);

        -- 이미지 UI 를 생성하는 구문 (버프/디버프 아이콘을 표시할때 사용)
        icon.texture = icon:CreateTexture(nil, "ARTWORK");

        -- 테스트 용도의 "W" 모양의 이미지 임시로 지정
        icon.texture:SetTexture([[interface\icons\TEMP]]);

        -- texture 의 부모인 icon 과 동일하게 크기, 위치 설정
        icon.texture:SetAllPoints();

        -- Cooldown : 액션바 쿨다운처럼 숫자와 원형 애니메이션이 돌아가는 UI
        -- (버프/디버프 지속시간을 위해 사용)
        icon.cooldown = CreateFrame("Cooldown", nil, icon);

        -- 원형으로 돌아가는 애니메이션을 사용하기 위해서는 이미지를 삽입해줘야 하는데,
        -- 간단한게 흰색 이미지를 생성해서 넣기로 하자
        local texture = icon:CreateTexture(nil,"OVERLAY");
         -- 이미지파일을 넣지 않아도 이렇게 색상을 지정하면 자동으로 단색 이미지 생성
        texture:SetTexture(1,1,1);

        -- 쿨다운 UI 에 위에서 만든 이미지를 삽입!
        icon.cooldown:SetSwipeTexture(texture:GetTexture());

        -- 쿨다운 애니메이션은 보통 검은색 반투명 이미지 이다!
        -- 따라서, 여기서 색상을 변경해서 사용해주자.
        -- 그럼 애초에 이미지 만들어서 넣을때,
        -- 흰색 말고 검은색 반투명 이미지 넣으면 되잖아? 라고 반문하실텐데..
        -- 쿨다운 UI 내부적으로 swipe 로 지정한 색과 넣은 이미지와 or연산 통하여 최종 이미지를 출력하기 때문에,
        -- 나중에 쿨다운 애니메이션 색상을 변경할 때의 편의성과 직관성을 위해서 여기서 지정하는게 낫다.
        icon.cooldown:SetSwipeColor(0,0,0, 0.7);
        icon.cooldown:SetDrawSwipe(true); -- 애니메이션 사용할꺼다 설정
        icon.cooldown:SetAllPoints();

        -- 버프/디버프의 중첩 숫자를 표시하기위해 Text UI 생성
        icon.countText = icon:CreateFontString(nil, "OVERLAY");
        -- OUTLINE 은 폰트를 굵고 테두리가 표시 되도록하는 옵션이다.
        icon.countText:SetFont([[Fonts\2002.TTF]], 10, "OUTLINE");
        icon.countText:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], 10);
        icon.countText:SetPoint("BOTTOMRIGHT", icon, "BOTTOMRIGHT");
        icon.countText:SetText("중첩"); -- 테스트용
        icon.countText:SetJustifyV("TOP");
        icon.countText:SetJustifyH("RIGHT");

        -- duration BuffFrame 흉내내기
        icon.duration = icon:CreateFontString(nil,"OVERLAY");
        icon.duration:SetFont(STANDARD_TEXT_FONT, math.max(LJDSpellInterruptDB["ICON_WIDTH"]/3, 7), "OUTLINE");
        --icon.duration:SetFontObject("GameFontNormalSmall");
        icon.duration:SetTextHeight(math.max(LJDSpellInterruptDB["ICON_WIDTH"]/3, 7));
        icon.duration:SetPoint("TOPLEFT", icon, "BOTTOMLEFT", 0, 0 )
        icon.duration:SetPoint("TOPRIGHT", icon, "BOTTOMRIGHT", 0, 0 )
        icon.duration:SetJustifyV("TOP");
        icon.duration:SetJustifyH("CENTER");

        -- 스킬시전자 표현 추가(20191112)
        icon.caster = icon:CreateFontString(nil,"OVERLAY");
        icon.caster:SetFont(STANDARD_TEXT_FONT, math.max(LJDSpellInterruptDB["ICON_WIDTH"]/3, 9), "OUTLINE");
        --icon.caster:SetFontObject("GameFontHighlightSmall");
        icon.caster:SetTextHeight(math.max(LJDSpellInterruptDB["ICON_WIDTH"]/3, 9));
        icon.caster:SetTextHeight(9);
        --icon.caster:SetPoint("BOTTOMLEFT", icon, "TOPLEFT", -2, 0 )
        --icon.caster:SetPoint("BOTTOMRIGHT", icon, "TOPRIGHT", 2, 0 )
        icon.caster:SetPoint("BOTTOM", icon, "TOP", 0, 0 ); -- 20191115 케릭의 긴 이름으로 인해 겹칠수 있는 설정이지만, 그래도 이름은 한줄에 표현되도록 하기 위해 감수함.

        icon.caster:SetJustifyV("TOP");
        icon.caster:SetJustifyH("CENTER");
        icon.caster:SetText("이진득성기사"); -- 테스트용
        --icon.caster:SetWordWrap(false); -- 자리넘어가면 .. 으로 대체

        -- 20191128 마훔가능 스킬여부
        icon.isStealable = nil;
        -- 20201115 해제가능 스킬여부
        icon.isDispellable = nil;

        self.icon[index] = icon; -- 만든 아이콘을 배열에 저장
        self.iconShownCount = self.iconShownCount and math.max(index, self.iconShownCount); -- 화면에 표현된 아이콘의 갯수저장.
        --print(self.iconShownCount);
        -- 마지막 아이콘에 More붙이기(보일때 위치만 잡는것)
        if(self.SpecialBuffMore) and (self.icon[self.iconShownCount]) then
            self.SpecialBuffMore:ClearAllPoints();
            self.SpecialBuffMore:SetPoint("BOTTOMLEFT", self.icon[self.iconShownCount], "BOTTOMRIGHT", 1, 0 );
        end
    end
    return icon; -- 아이콘 반환
end

-- 내 케릭 전용 큰버프 아이콘프레임
function createPlayerBigBuffFrame()

    -- 이미 있으면 생성안함.
    if( _G["PlayerBigBuffFrame"] ) then
        return;
    end

    -- 내케릭용 큰아이콘
    --local playerBigBuffFrame = CreateFrame ("frame", "PlayerBigBuffFrame")
    -- 20190901 동영상플레이 또는 전체화면캡쳐용화면시 빅버프숨김효과위해 PlayerFrameHealthBar 상속처리
    local playerBigBuffFrame = CreateFrame ("frame", "PlayerBigBuffFrame", PlayerFrame);

    playerBigBuffFrame:SetPoint("BOTTOM", PlayerName          , "TOP" , 0 ,5 );
    --playerBigBuffFrame:SetPoint("LEFT"  , PlayerFrameHealthBar, "LEFT", 0 ,0 );
    playerBigBuffFrame:SetPoint("LEFT"  , PlayerName, "LEFT", 0 ,0 );

    playerBigBuffFrame:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]*2.3);
    playerBigBuffFrame:EnableMouse (false);
    playerBigBuffFrame:SetFrameStrata ("BACKGROUND");

    playerBigBuffFrame.icon={};
    playerBigBuffFrame.iconShownCount=0;

    playerBigBuffFrame.filter = nil;
    playerBigBuffFrame.isBuff = true;
    playerBigBuffFrame:Hide(); -- /fstack 디버깅모드시 오류회피

end

function createHighlightBuffFrame(plateFrame)

    -- 이미 있으면 생성안함.
    if( _G[plateFrame:GetName().."HighlightBuffFrame"] ) then
        return;
    end

    --local sizeWidth, sizeHeight = 25, 25;
    local fontSizeHeight = 8;
    --local highlightBuffFrame = CreateFrame ("frame", "$parentHighlightBuffFrame", plateFrame)
    local highlightBuffFrame = CreateFrame ("frame", "$parentHighlightBuffFrame", plateFrame)
    --local highlightBuffFrame = CreateFrame ("frame", "$parentHighlightBuffFrame", UIParent)

    highlightBuffFrame:SetPoint("LEFT", plateFrame.UnitFrame.healthBar, "RIGHT", 8, 0 );
    highlightBuffFrame:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]);
    --highlightBuffFrame:SetAllPoints();
    highlightBuffFrame:EnableMouse (false);
    highlightBuffFrame:SetFrameStrata ("BACKGROUND");
    --highlightBuffFrame:SetFrameLevel(1);

    highlightBuffFrame.icon={};
    highlightBuffFrame.iconShownCount=0;

    highlightBuffFrame.filter = nil;
    highlightBuffFrame.isBuff = true;

    -- 아직 설정못함. unit 없음.
    -- NAME_PLATE_UNIT_ADDED 이벤트처리 핸들러에서 재설정함.

    --highlightBuffFrame.unit = plateFrame.UnitFrame.unit;
    --highlightBuffFrame:SetAttribute("unit", highlightBuffFrame.unit);

    -- More~~
    highlightBuffFrame.SpecialBuffMore = highlightBuffFrame:CreateFontString(nil,"OVERLAY"); -- create texture as child of myframe
    --highlightBuffFrame.SpecialBuffMore:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], 15);
    highlightBuffFrame.SpecialBuffMore:SetFontObject("GameFontHighlight");
    highlightBuffFrame.SpecialBuffMore:SetText("More...");
    highlightBuffFrame.SpecialBuffMore:SetJustifyV("CENTER");
    highlightBuffFrame.SpecialBuffMore:SetJustifyH("LEFT");
    highlightBuffFrame.SpecialBuffMore:Hide();

    --highlightBuffFrame:SetScript("OnUpdate", HighlightBuffFrame_OnUpdate    );    -- 버프 최상위 프레임 변경이벤트
    highlightBuffFrame:Hide(); -- /fstack 디버깅모드시 오류회피

    plateFrame.highlightBuffFrame = highlightBuffFrame;

    -- 큰아이콘
    local highlightBigBuffFrame = CreateFrame ("frame", "$parentHighlightBigBuffFrame", plateFrame)

    highlightBigBuffFrame:SetPoint("BOTTOMLEFT", highlightBuffFrame, "TOPLEFT", 0, 1 );
    highlightBigBuffFrame:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]*2.3);
    highlightBigBuffFrame:EnableMouse (false);
    highlightBigBuffFrame:SetFrameStrata ("BACKGROUND");

    highlightBigBuffFrame.icon={};
    highlightBigBuffFrame.iconShownCount=0;

    highlightBigBuffFrame.filter = nil;
    highlightBigBuffFrame.isBuff = true;
    highlightBigBuffFrame:Hide(); -- /fstack 디버깅모드시 오류회피

    plateFrame.highlightBigBuffFrame = highlightBigBuffFrame;
end

function createHighlightDeBuffFrame(plateFrame)

    -- 이미 있으면 생성안함.
    if( _G[plateFrame:GetName().."HighlightDeBuffFrame"] ) then
        return;
    end

    local highlightDeBuffFrame = CreateFrame ("frame", "$parentHighlightDeBuffFrame", plateFrame)
    highlightDeBuffFrame:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]);

    highlightDeBuffFrame:SetPoint("LEFT"  , plateFrame.UnitFrame.healthBar.border, "TOPLEFT", 0 ,0 );
    highlightDeBuffFrame:SetPoint("BOTTOM", plateFrame.UnitFrame.name            , "TOP"    , 0 ,0 );
    --highlightDeBuffFrame:SetPoint("BOTTOMLEFT", plateFrame.UnitFrame.name, "TOPLEFT", 0, 12 )
    --highlightDeBuffFrame:SetPoint("BOTTOMLEFT", plateFrame.UnitFrame.healthBar, "TOPLEFT", 0, 0 );
    highlightDeBuffFrame:EnableMouse (false);
    highlightDeBuffFrame:SetFrameStrata ("BACKGROUND");
    --highlightDeBuffFrame:SetFrameLevel(1);

    highlightDeBuffFrame.icon={};
    highlightDeBuffFrame.iconShownCount=0;

    highlightDeBuffFrame.filter = nil;
    highlightDeBuffFrame.isBuff = false;

    -- More~~
    highlightDeBuffFrame.SpecialBuffMore = highlightDeBuffFrame:CreateFontString(nil,"OVERLAY"); -- create texture as child of myframe
    highlightDeBuffFrame.SpecialBuffMore:SetFontObject("GameFontHighlight");
    highlightDeBuffFrame.SpecialBuffMore:SetText("More...");
    highlightDeBuffFrame.SpecialBuffMore:SetJustifyV("CENTER");
    highlightDeBuffFrame.SpecialBuffMore:SetJustifyH("LEFT");
    highlightDeBuffFrame.SpecialBuffMore:Hide();

    highlightDeBuffFrame:Hide();
    plateFrame.highlightDeBuffFrame = highlightDeBuffFrame;

    -- 큰아이콘
    local highlightBigDeBuffFrame = CreateFrame ("frame", "$parentHighlightBigDeBuffFrame", plateFrame)
    highlightBigDeBuffFrame:SetSize(LJDSpellInterruptDB["ICON_WIDTH"], LJDSpellInterruptDB["ICON_HEIGHT"]*3);
    highlightBigDeBuffFrame:SetPoint("BOTTOMLEFT", highlightDeBuffFrame, "TOPLEFT", 0, 1 )
    highlightBigDeBuffFrame:EnableMouse (false);
    highlightBigDeBuffFrame:SetFrameStrata ("BACKGROUND");

    highlightBigDeBuffFrame.icon={};
    highlightBigDeBuffFrame.iconShownCount=0;

    highlightBigDeBuffFrame.filter = nil;
    highlightBigDeBuffFrame.isBuff = false;
    highlightBigDeBuffFrame:Hide(); -- /fstack 디버깅모드시 오류회피
    
    plateFrame.highlightBigDeBuffFrame = highlightBigDeBuffFrame;

end

function removeHighlightFrame(self)

    self.iconShownCount=0;
    -- 모두 숨김처리
    for i = 1, #self.icon do
        self.icon[i]:Hide();
        self.icon[i]:SetScript("OnUpdate", nil);
        self.icon[i]:SetScript("OnEnter", nil);
        self.icon[i]:SetScript("OnLeave", nil);
    end
    
    self:Hide(); -- /fstack 디버깅모드시 오류회피

end

function HighlightBuffFrame_Update(self, filter)
    -- More 초기화
    self.SpecialBuffMore:Hide();
    --print(filter);

    self.filter = filter;
    local IndexIcon = 0;

    -- 20191113
    -- 버프는 역순으로 정렬
    for i= BUFF_MAX_DISPLAY, 1, -1  do

        local auraInfo = {};
        auraInfo={UnitAura(self.unit, i, filter)};
        --auraInfo={UnitDebuff(plateFrame.UnitFrame.unit, i)};

        local debugName={"name", "icon", "count", "dispelType", "duration", "expires", "unitCaster", "isStealable", "nameplateShowPersonal", "spellID", "canApplyAura", "isBossDebuff", "isCastByPlayer", "nameplateShowAll", "timeMod","","","","","","","",""}
        --DebugPrint(auraInfo, debugName);

        --if #auraInfo == 0 then
        --    break;
        --end

        --if(auraInfo[2] == nil) then print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!") end;

        local CheckFilterSkill = true;

        -- 아군 버프 표현안함.
        if UnitIsUnit("player", self.unit) then
            -- 내 케릭
            CheckFilterSkill = true;
        else
            local reaction = UnitReaction("player", self.unit);
            if reaction and reaction <= 4 then
                -- Reaction 4 is neutral and less than 4 becomes increasingly more hostile
                -- 적
                CheckFilterSkill = true;
            else
                -- 아군
                --CheckFilterSkill = false;
                CheckFilterSkill = LJDSpellInterruptDB["ShowFriendsSpecialBuff"];   -- 아군버프 표현 디버깅 설정기능 추가
            end
        end

        -- 목록에 있으면 아이콘 생성안함.
        --local FilterSkilList={"참전 중","언더시티 용사","오그리마 용사", "호드 병사", "자체 의존"};
        local FilterSkilList={};

        for j=1, #FilterSkilList do
            if auraInfo[1] == FilterSkilList[j] then
                CheckFilterSkill = false;
                break;
            end;
        end

        -- 20191113
        -- for문을 역순으로 수행하다보니 auraInfo가 없을수 있음
        -- continue구문을 사용할수 없음에 따라 CheckFilterSkill 변수를 이용해
        -- 아래처럼 모두 표현안함 처리.
        if #auraInfo == 0 then
            CheckFilterSkill = false;
        end

        if ( CheckFilterSkill ) then

            IndexIcon = IndexIcon + 1;
            --print( auraInfo[6] - auraInfo[5], GetTime(), auraInfo[5]  );

            if(IndexIcon > LJDSpellInterruptDB["NumberLimitSpecialBuff"]) and (self.icon[self.iconShownCount]) then
                self.SpecialBuffMore:SetText("|cfff48cbaMore "..(IndexIcon-LJDSpellInterruptDB["NumberLimitSpecialBuff"]).."|r");
                self.SpecialBuffMore:SetPoint("BOTTOMLEFT", self.icon[self.iconShownCount], "BOTTOMRIGHT", 1, 0 );

                self.SpecialBuffMore:Show();
                --break;
            else
                self.SpecialBuffMore:SetText("");
                self.SpecialBuffMore:Hide();
            end

            local icon = GetIcon(self, IndexIcon);
            icon.texture:SetTexture(auraInfo[2]); -- 이미지를 넣어주고

            -- 쿨다운 UI 를 실행하는 함수이다.
            -- 1번째 인자로, 오라의 시작 시간 (초단위며, 시작 시간을 얻기 위해 종료시간에서 지속시간을 뺌)
            -- 2번째 인자로, 지속시간을 넣어주면 된다.
            -- 함수를 실행하는 순간! 자동으로 애니메이션과 숫자가 표시된다!
            --icon.cooldown:SetCooldown(auraInfo[6]-auraInfo[5], auraInfo[5]);
            if auraInfo[5] > 0 then
                icon.cooldown:Show();
                CooldownFrame_Set(icon.cooldown, auraInfo[6]-auraInfo[5], auraInfo[5], auraInfo[5]>0, true);
            else
                icon.cooldown:Hide();
            end;

            -- 쿨다운 카운트다운 제거할지 설정변수
            icon.cooldown:SetHideCountdownNumbers(LJDSpellInterruptDB["HideCountdownNumbers"]);

            -- 버프이므로 Cooldown 상태 강조위해 반전
            icon.cooldown:SetReverse(true);

            -- BuffFrame의 카운트다운 흉내내기
            icon.expirationTime = auraInfo[6];
            icon.timeLeft = ceil(icon.expirationTime - GetTime());  -- floor ( 0초 표현하지 않도록 수정 )
            local duration = {"%s", ""};
            if( auraInfo[5] > 0 ) then duration = {SecondsToTimeAbbrev(icon.timeLeft)}; end;
            icon.duration:SetFormattedText(unpack(duration));

            -- 20191112 스킬시전자 추가
            -- 몹 또는 NPC 시전 제외(UnitPlayerControlled이용)
            icon.caster:SetText("");
            --if( auraInfo[7] and UnitPlayerControlled( auraInfo[7] ) ) then
            if( auraInfo[7] and auraInfo[13] ) then
                local className, classFilename, classID = UnitClass(auraInfo[7]);
                local rPerc, gPerc, bPerc, argbHex = GetClassColor(classFilename);
                local casterName = UnitName(auraInfo[7]);
                if UnitIsUnit("player", auraInfo[7]) then
                    casterName = L["나"];
                end;

                icon.caster:SetText("|c"..argbHex..""..casterName.."|r");

                -- 자기한테 시전한 버프는 시전자 표현 안함.(isCastByPlayer)
                if UnitIsUnit(self.unit, auraInfo[7]) then
                    icon.caster:SetText("");
                end
            end

            icon.isStealable = auraInfo[8]; -- 마훔가능여부 저장

            -- 중첩이 1 이하는 표현할 필요 없으니, 2이상만 표시
            if auraInfo[3] > 1 then
                icon.countText:SetText(auraInfo[3]);
            else
                icon.countText:SetText(nil);
            end
            -- 아이콘에 정보를 담았으니 출력
            icon:Show();

            -- 툴팁연결을 위한 변수추가
            icon.unitId = self.unit;
            icon:SetID(i);

            -- 아이콘 툴팁 연결 (option 적용)
            if( LJDSpellInterruptDB["ShowSpecialBuffTooltip"] ) then
                -- 없는 경우만 재지정한다.
                -- OnUpdate는 별로 타이머로 구현.
                --icon:SetScript("OnUpdate", HighlightBuffFrame_AuraOnUpdate    );
                if( not icon:GetScript("OnEnter") ) then icon:SetScript("OnEnter" , HighlightBuffFrame_AuraOnMouseEnter); end;
                if( not icon:GetScript("OnLeave") ) then icon:SetScript("OnLeave" , HighlightBuffFrame_AuraOnMouseLeave); end;
                if( not icon:GetScript("OnClick") ) then icon:SetScript("OnClick" , HighlightBuffFrame_AuraOnMouseClick); end;
            else
                --icon:SetScript("OnUpdate", nil                                );
                icon:SetScript("OnEnter" , nil                                );
                icon:SetScript("OnLeave" , nil                                );
                icon:SetScript("OnClick" , nil                                );
            end

            -------------------------------------------------------
            -- 프레임크기 재지정
            -- ; 추후 다른 프레임의 위치 참조용(현재는 의미없음)
            -------------------------------------------------------
            if IndexIcon == 1 then
                local durationHeight = (icon:GetHeight()/3);    -- 아이콘 만들때 duration은 아이콘의 1/3로 만들었음.
                local iconHeight =  icon:GetHeight() + 1;      -- 아이콘 border 감안
                self:SetSize(300, iconHeight + durationHeight);

                self:SetPoint("LEFT", self:GetParent().UnitFrame.healthBar, "RIGHT", 8, ( (durationHeight/2) * -1 ) );
            end

            --------------------------------------------------------------------------------------------
            -- border 처리
            -- ; 아이콘 기준으로 움직이지만, 아이콘보다 back에 존재해서 Anchor 형태로 처리할수 없었다.
            --   (아이콘보다 앞으로 가져오면 아이콘은 전체적으로 붉은색으로 변함)
            --   그래서, 아이콘이 변경될때, border도 동기화 처리함.
            --------------------------------------------------------------------------------------------
            icon.border:SetSize(icon:GetWidth() + 2, icon:GetHeight() + 2);
            icon.border:SetPoint("BOTTOMLEFT", icon, "BOTTOMLEFT", -1, -1);
            -- 주요 확인
            --print("    " .. tostring(IndexIcon)..":".. auraInfo[1].."("..auraInfo[2]..")" );

        end;

        --@LJD_continue:

    end;

    -- 최대표현 icon갯수를 넘은 경우
    -- More 문구가 나타난 경우는 최대표현아이콘수를 넘어선 경우이므로 아이콘생성안함.
    -- 단지, "More N개"의 표현을 위해 계속 돌림.
    if( self.SpecialBuffMore:IsShown() ) then

        for IndexRemove = (LJDSpellInterruptDB["NumberLimitSpecialBuff"]+1), BUFF_MAX_DISPLAY do
            if( self.icon[IndexRemove] and self.icon[IndexRemove]:IsShown() ) then
                self.icon[IndexRemove]:Hide();
            end;
        end

        IndexIcon = LJDSpellInterruptDB["NumberLimitSpecialBuff"];
    end

    -- 오라가 계속 생겼다가 사라졌다가 하니, 안쓰는 아이콘은 삭제하는것보다
    -- hide 로 안보이게 해두는게 효율적이다.
    for IndexRemove = (IndexIcon+1), #self.icon do
        if( self.icon[IndexRemove] and self.icon[IndexRemove]:IsShown() ) then
            --self.icon[IndexRemove].texture:Hide();
            --self.icon[IndexRemove]:SetScript("OnUpdate", nil);
            --self.icon[IndexRemove]:SetScript("OnEnter", nil);
            --self.icon[IndexRemove]:SetScript("OnLeave", nil);
            self.icon[IndexRemove]:Hide();
            --self.icon[IndexRemove].cooldown:Clear();
        end;
    end

    self.iconShownCount = IndexIcon; -- 현재보여진 아이콘수를 저장(More.. 메시지를 젤 마지막아이콘에 붙이기 위해)
--end

end

function HighlightDeBuffFrame_Update(self, filter)
    --print(filter);
    -- More 초기화
    self.SpecialBuffMore:Hide();

    self.filter = filter;
    local IndexIcon = 0;
    local IndexBigIcon = 0;

    for i= 1, BUFF_MAX_DISPLAY do

        local auraInfo = {};
        auraInfo={UnitAura(self.unit, i, filter)};
        --auraInfo={UnitDebuff(self.unit, i, filter)};
        --auraInfo={UnitDebuff(plateFrame.UnitFrame.unit, i)};

        local debugName={"name", "icon", "count", "dispelType", "duration", "expires", "unitCaster", "canStealOrPurge", "nameplateShowPersonal", "spellID", "canApplyAura", "isBossDebuff", "isCastByPlayer", "nameplateShowAll", "timeMod","","","","","","","",""}
        --DebugPrint(auraInfo, debugName);

        if ( #auraInfo == 0 ) then
            break;
        end

        --if(auraInfo[2] == nil) then print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!") end;

        local CheckFilterSkill = true;

        -- 아군 디버프 표현안함.
        if UnitIsUnit("player", self.unit) then
            -- 내 케릭
            CheckFilterSkill = true;
        else
            local reaction = UnitReaction("player", self.unit);
            if reaction and reaction <= 4 then
                -- Reaction 4 is neutral and less than 4 becomes increasingly more hostile
                -- 적
                CheckFilterSkill = true;
                
                -------------------------------------------------
                -- 20191217
                -- 적 이름표에는 내가건 디버프만 보기 기능 추가
                -------------------------------------------------
                if( LJDSpellInterruptDB["ShowOnlyPlayerDeBuff"] ) then
                    if( not UnitIsUnit("player", (auraInfo[7] or "")) ) then
                    --if( not auraInfo[13]) then
                        --DebugPrint(auraInfo[1]..":"..tostring(auraInfo[13]));
                        --DebugPrint(auraInfo[1].." ".."숨김,");
                        CheckFilterSkill = false;
                    end
                end
                
            else
                -- 아군
                --CheckFilterSkill = false;
                CheckFilterSkill = LJDSpellInterruptDB["ShowFriendsSpecialDeBuff"]; -- 아군디버프 표현 디버깅 설정기능 추가
            end
        end

        -- 목록에 있으면 아이콘 생성안함.
        --local FilterSkilList={"시간 변위"};
        local FilterSkilList={};

        for j=1, #FilterSkilList do
            if auraInfo[1] == FilterSkilList[j] then
                CheckFilterSkill = false;
                break;
            end;
        end

        ---------------------------------------------
        -- 타켓 프레임의 디버프와 동일하게 보이기
        ---------------------------------------------
        --if ( not TargetFrame_ShouldShowDebuffs(self.unit, caster, nameplateShowAll, casterIsPlayer) ) then
        
        -- 20221030
        --if ( not TargetFrame_ShouldShowDebuffs(self.unit, auraInfo[7], auraInfo[14], auraInfo[13]) ) then
        --    CheckFilterSkill = false;
        --end

        if ( CheckFilterSkill ) then

            IndexIcon = IndexIcon + 1;
            --print( auraInfo[6] - auraInfo[5], GetTime(), auraInfo[5]  );

            if(IndexIcon > LJDSpellInterruptDB["NumberLimitSpecialDeBuff"]) and (self.icon[self.iconShownCount]) then
                self.SpecialBuffMore:SetText("|cfff48cbaMore "..(IndexIcon-LJDSpellInterruptDB["NumberLimitSpecialDeBuff"]).."|r");
                self.SpecialBuffMore:SetPoint("BOTTOMLEFT", self.icon[self.iconShownCount], "BOTTOMRIGHT", 1, 0 );

                self.SpecialBuffMore:Show();
                --break;
            else
                self.SpecialBuffMore:SetText("");
                self.SpecialBuffMore:Hide();
            end

            local icon = GetIcon(self, IndexIcon);
            icon.texture:SetTexture(auraInfo[2]); -- 이미지를 넣어주고

            -- 쿨다운 UI 를 실행하는 함수이다.
            -- 1번째 인자로, 오라의 시작 시간 (초단위며, 시작 시간을 얻기 위해 종료시간에서 지속시간을 뺌)
            -- 2번째 인자로, 지속시간을 넣어주면 된다.
            -- 함수를 실행하는 순간! 자동으로 애니메이션과 숫자가 표시된다!
            --icon.cooldown:SetCooldown(auraInfo[6]-auraInfo[5], auraInfo[5]);
            if auraInfo[5] > 0 then
                icon.cooldown:Show();
                CooldownFrame_Set(icon.cooldown, auraInfo[6]-auraInfo[5], auraInfo[5], auraInfo[5]>0, true);
            else
                icon.cooldown:Hide();
            end;

            -- 쿨다운 카운트다운 제거할지 설정변수
            icon.cooldown:SetHideCountdownNumbers(LJDSpellInterruptDB["HideCountdownNumbers"]);

            -- 버프이므로 Cooldown 상태 강조위해 반전
            icon.cooldown:SetReverse(true);

            -- BuffFrame의 카운트다운 흉내내기
            icon.expirationTime = auraInfo[6];
            icon.timeLeft = ceil(icon.expirationTime - GetTime());  -- floor ( 0초 표현하지 않도록 수정 )
            local duration = {"%s", ""};
            if( auraInfo[5] > 0 ) then duration = {SecondsToTimeAbbrev(icon.timeLeft)}; end;
            icon.duration:SetFormattedText(unpack(duration));

            -- 20191112 스킬시전자 추가
            -- 몹 또는 NPC 시전 제외(UnitPlayerControlled이용)
            icon.caster:SetText("");
            --if( auraInfo[7] and UnitPlayerControlled( auraInfo[7] ) ) then
            if( auraInfo[7] and auraInfo[13] ) then
                local className, classFilename, classID = UnitClass(auraInfo[7]);
                local rPerc, gPerc, bPerc, argbHex = GetClassColor(classFilename);
                local casterName = UnitName(auraInfo[7]);
                if UnitIsUnit("player", auraInfo[7]) then
                    casterName = L["나"];
                end;

                icon.caster:SetText("|c"..argbHex..""..casterName.."|r");

                -- 자기한테 시전한 디버프는 시전자 표현 안함.(isCastByPlayer)
                -- 내 버프가 동반한 디버프인 경우 => 이름 표현 안함.
                if UnitIsUnit(self.unit, auraInfo[7]) then
                    icon.caster:SetText("");
                end
            end

            -- 해제가능한 오라정보
            local dispellableAutaInfo = {AuraUtil.FindAuraByName(auraInfo[1], self.unit, "HARMFUL|RAID")};
            icon.isStealable = auraInfo[8]; -- 마훔가능여부 저장
            icon.isDispellable = auraInfo[4] and dispellableAutaInfo[4]; -- 해제가능 저장
            
            -- 아이콘테두리색 지정`
            if( not self.isBuff ) then
                icon.border:SetColorTexture(1,0,0,0.5); -- 디버프용 테두리 빨강
            else
                icon.border:SetColorTexture(0,0,0,0);       -- 버프용 테두리 없음
            end
            
            -- 20201115 아군의 해제가능한 디버프 표시
            if( icon.isDispellable and ( not self.isBuff) ) then
                local reaction = UnitReaction("player", self.unit);
                if reaction and reaction > 4 then

                    -- 해제가능한 마법 디버프 재확인
                    if IsDispelableMagicDebuff(icon.isDispellable) then
                        icon.border:SetColorTexture(0,1,0,0.8); -- 해제가능하면 테두리 초록
                    else
                        icon.isDispellable = nil; -- 마법해제 불가 재설정(HighlightBuffFrame_AuraOnUpdate 에서도 참조하도록)
                    end

                    --[[
                    -- 해제가능한 디버프 목록 모두 로깅 : 성기사는 보기도 마법해제 가능한 것으로 로깅됨.
                    local j = 0;
                    AuraUtil.ForEachAura(self.unit, "HARMFUL|RAID", BUFF_MAX_DISPLAY, function(...)
                        local ll = {...};
                        j = j + 1;
                        DebugPrint(j..ll[1])
                    end);
                    --]]

                    --DebugPrint("["..icon.isDispellable.."]");
                    --DebugPrint("[>"..auraInfo[4].."]");
                    --DebugPrint("A "..auraInfo[1]..":"..auraInfo[10]..":"..tostring(auraInfo[8]));
                    --DebugPrint("B "..dispellableAutaInfo[1]..":"..dispellableAutaInfo[10]..":"..tostring(dispellableAutaInfo[8]));
                    --DebugPrint(auraInfo, debugName);
                    --DebugPrint(dispellableAutaInfo, debugName);
                    --DebugPrint(self.unit..":"..auraInfo[1].."1:"..auraInfo[4]);
                    --DebugPrint(self.unit..":"..auraInfo[1].."2:"..select(4, AuraUtil.FindAuraByName(auraInfo[1], self.unit, "HARMFUL|RAID")));
                    --DebugPrint(self.unit..":"..auraInfo[1].."3:"..icon.isDispellable);
                    --DebugPrintTable({AuraUtil.FindAuraByName(auraInfo[1], self.unit, "HARMFUL|RAID")});
                end
            end
            
            if( icon.isStealable == true ) then
                icon.border:SetColorTexture(1,1,1,0.8); -- 마법훔치기가능 테두리 흰색(가장 우선순위 높음)
            end

            -- 중첩이 1 이하는 표현할 필요 없으니, 2이상만 표시
            if auraInfo[3] > 1 then
                icon.countText:SetText(auraInfo[3]);
            else
                icon.countText:SetText(nil);
            end

            -- 아이콘에 정보를 담았으니 출력
            icon:Show();

            -- 툴팁연결을 위한 변수추가
            icon.unitId = self.unit;
            icon:SetID(i);

            -- 아이콘 툴팁 연결 (option 적용)
            if( LJDSpellInterruptDB["ShowSpecialDeBuffTooltip"] ) then
                -- 없는 경우만 재지정한다.
                -- OnUpdate는 별로 타이머로 구현.
                --icon:SetScript("OnUpdate", HighlightBuffFrame_AuraOnUpdate    );
                if( not icon:GetScript("OnEnter") ) then icon:SetScript("OnEnter" , HighlightBuffFrame_AuraOnMouseEnter); end;
                if( not icon:GetScript("OnLeave") ) then icon:SetScript("OnLeave" , HighlightBuffFrame_AuraOnMouseLeave); end;
                --if( not icon:GetScript("OnClick") ) then icon:SetScript("OnClick" , HighlightBuffFrame_AuraOnMouseClick); end;
            else
                --icon:SetScript("OnUpdate", nil                                );
                icon:SetScript("OnEnter" , nil                                );
                icon:SetScript("OnLeave" , nil                                );
                --icon:SetScript("OnClick" , nil                                );
            end

            -------------------------------------------------------
            -- 프레임크기 재지정
            -- ; 추후 다른 프레임의 위치 참조용(현재는 의미없음)
            -------------------------------------------------------
            if IndexIcon == 1 then
                local durationHeight = (icon:GetHeight()/3);    -- 아이콘 만들때 duration은 아이콘의 1/3로 만들었음.
                local iconHeight =  icon:GetHeight() + 1;      -- 아이콘 border 감안
                self:SetSize(300, iconHeight + durationHeight);
                --self:SetPoint("LEFT", self:GetParent().UnitFrame.name, "RIGHT", 0, ( durationHeight * -1 ) );

                -- 디버프 위치( duration 추가된 만큼 디버프 위치 이동, 내 케릭은 체력바위, 그외 nameplate는 이름위로 )
                if UnitIsUnit("player", self.unit) then
                    -- 내 케릭은 체력바 위로(이름이 없으니..)
                    self:ClearAllPoints();
                    self:SetPoint("BOTTOMLEFT", self:GetParent().UnitFrame.healthBar.border, "TOPLEFT", 0 ,0 );
                else
                    -- 그외 nameplate는 이름위로
                    self:ClearAllPoints();
                    self:SetPoint("LEFT"  , self:GetParent().UnitFrame.healthBar.border, "TOPLEFT", 0 ,0 );
                    self:SetPoint("BOTTOM", self:GetParent().UnitFrame.name, "TOP", 0 ,0 );
                end

            end

            --------------------------------------------------------------------------------------------
            -- border 처리
            -- ; 아이콘 기준으로 움직이지만, 아이콘보다 back에 존재해서 Anchor 형태로 처리할수 없었다.
            --   (아이콘보다 앞으로 가져오면 아이콘은 전체적으로 붉은색으로 변함)
            --   그래서, 아이콘이 변경될때, border도 동기화 처리함.
            --------------------------------------------------------------------------------------------
            icon.border:SetSize(icon:GetWidth() + 2, icon:GetHeight() + 2);
            icon.border:SetPoint("BOTTOMLEFT", icon, "BOTTOMLEFT", -1, -1);

            -- 주요 확인
            --print("    " .. tostring(IndexIcon)..":".. auraInfo[1].."("..auraInfo[2]..")" );

        end;
    end;

    -- 최대표현 icon갯수를 넘은 경우
    -- More 문구가 나타난 경우는 최대표현아이콘수를 넘어선 경우이므로 아이콘생성안함.
    -- 단지, "More N개"의 표현을 위해 계속 돌림.
    if( self.SpecialBuffMore:IsShown() ) then

        for IndexRemove = (LJDSpellInterruptDB["NumberLimitSpecialDeBuff"]+1), BUFF_MAX_DISPLAY do
            if( self.icon[IndexRemove] and self.icon[IndexRemove]:IsShown() ) then
                self.icon[IndexRemove]:Hide();
            end;
        end

        IndexIcon = LJDSpellInterruptDB["NumberLimitSpecialDeBuff"];
    end

    -- 오라가 계속 생겼다가 사라졌다가 하니, 안쓰는 아이콘은 삭제하는것보다
    -- hide 로 안보이게 해두는게 효율적이다.
    for IndexRemove = (IndexIcon+1), #self.icon do
        if( self.icon[IndexRemove] and self.icon[IndexRemove]:IsShown() ) then
            --self.icon[IndexRemove].texture:Hide();
            --self.icon[IndexRemove]:SetScript("OnUpdate", nil);
            --self.icon[IndexRemove]:SetScript("OnEnter", nil);
            --self.icon[IndexRemove]:SetScript("OnLeave", nil);
            self.icon[IndexRemove]:Hide();
            --self.icon[IndexRemove].cooldown:Clear();
        end;
    end

    self.iconShownCount = IndexIcon; -- 현재보여진 아이콘수를 저장(More.. 메시지를 젤 마지막아이콘에 붙이기 위해)
--end
end


function HighlightBigBuffFrame_Update(self, filter)

    self.filter = filter;
    local IndexIcon = 0;

    for i= 1, BUFF_MAX_DISPLAY do

        local auraInfo = {};
        auraInfo={UnitAura(self.unit, i, filter)};
        --auraInfo={UnitDebuff(plateFrame.UnitFrame.unit, i)};

        local debugName={"name", "icon", "count", "dispelType", "duration", "expires", "unitCaster", "canStealOrPurge", "nameplateShowPersonal", "spellID", "canApplyAura", "isBossDebuff", "isCastByPlayer", "nameplateShowAll", "timeMod","","","","","","","",""}
        --DebugPrint(auraInfo, debugName);

        if #auraInfo == 0 then
            break;
        end

        --if(auraInfo[2] == nil) then print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!") end;

        local CheckShowBigSkil = false;

        -- 크게 표현할 아이콘목록
        --local ShowBigBuffSkilList={"울려퍼지는 보호", "전투의 징후", "고위 천사", };  -- 디버깅용
        --local ShowBigBuffSkilList={"고위 천사", "불안정한 마나진주", "정의의 방패", "울려퍼지는 보호"};

        for j=1, #ShowBigBuffSkilList do
            if auraInfo[1] == ShowBigBuffSkilList[j] then
                CheckShowBigSkil = true;
                break;
            end;
        end

        -- 한번 더 체크(아군 제외하려고..)
        if CheckShowBigSkil then
            -- 아군
            if UnitIsUnit("player", self.unit) then
                -- 내 케릭 버프 표현안함.(별도 프레임으로 표현됨 PlayerBigBuffFrame)
                CheckShowBigSkil = false;
            else
                local reaction = UnitReaction("player", self.unit);
                if reaction and reaction <= 4 then
                    -- Reaction 4 is neutral and less than 4 becomes increasingly more hostile
                    -- 적
                    CheckShowBigSkil = true;
                else
                    -- 아군 버프 표현안함.
                    --CheckShowBigSkil = false;
                    CheckShowBigSkil = LJDSpellInterruptDB["ShowFriendsSpecialBuff"];   -- 아군버프 표현 디버깅 설정기능 추가
                end
            end
        end

        if CheckShowBigSkil then
            --print("크게 표현될 아이콘~");
            --DebugPrint(auraInfo);
            IndexIcon = IndexIcon + 1;

            local icon = GetIcon(self, IndexIcon);
            icon.texture:SetTexture(auraInfo[2]); -- 이미지를 넣어주고

            -- 쿨다운 UI 를 실행하는 함수이다.
            -- 1번째 인자로, 오라의 시작 시간 (초단위며, 시작 시간을 얻기 위해 종료시간에서 지속시간을 뺌)
            -- 2번째 인자로, 지속시간을 넣어주면 된다.
            -- 함수를 실행하는 순간! 자동으로 애니메이션과 숫자가 표시된다!
            --icon.cooldown:SetCooldown(auraInfo[6]-auraInfo[5], auraInfo[5]);
            if auraInfo[5] > 0 then
                icon.cooldown:Show();
                CooldownFrame_Set(icon.cooldown, auraInfo[6]-auraInfo[5], auraInfo[5], auraInfo[5]>0, true);
            else
                icon.cooldown:Hide();
            end;

            -- 쿨다운 카운트다운 제거할지 설정변수
            icon.cooldown:SetHideCountdownNumbers(false);

            -- 버프이므로 Cooldown 상태 강조위해 반전
            icon.cooldown:SetReverse(true);

            -- BuffFrame의 카운트다운 흉내내기
            --[[
            icon.expirationTime = auraInfo[6];
            icon.timeLeft = ceil(icon.expirationTime - GetTime());
            local duration = {"%s", ""};
            if( auraInfo[5] > 0 ) then duration = {SecondsToTimeAbbrev(icon.timeLeft)}; end;
            icon.duration:SetFormattedText(unpack(duration));
            --]]

            -- 중첩이 1 이하는 표현할 필요 없으니, 2이상만 표시
            if auraInfo[3] > 1 then
                icon.countText:SetText(auraInfo[3]);
            else
                icon.countText:SetText(nil);
            end
            -- 아이콘에 정보를 담았으니 출력
            icon:Show();

            -- 툴팁연결을 위한 변수추가
            icon.unitId = self.unit;
            icon:SetID(i);

            icon.isStealable = auraInfo[8]; -- 마훔가능여부 저장

            -- 아이콘 툴팁 연결 (option 적용)
            if( LJDSpellInterruptDB["ShowSpecialBuffTooltip"] ) then
                -- 없는 경우만 재지정한다.
                -- OnUpdate는 별로 타이머로 구현.
                --icon:SetScript("OnUpdate", HighlightBuffFrame_AuraOnUpdate    );
                if( not icon:GetScript("OnEnter") ) then icon:SetScript("OnEnter" , HighlightBuffFrame_AuraOnMouseEnter); end;
                if( not icon:GetScript("OnLeave") ) then icon:SetScript("OnLeave" , HighlightBuffFrame_AuraOnMouseLeave); end;
                --if( not icon:GetScript("OnClick") ) then icon:SetScript("OnClick" , HighlightBuffFrame_AuraOnMouseClick); end;
            else
                --icon:SetScript("OnUpdate", nil                                );
                icon:SetScript("OnEnter" , nil                                );
                icon:SetScript("OnLeave" , nil                                );
                --icon:SetScript("OnClick" , nil                                );
            end

            ------------------------------------------
            -- 큰아이콘화 처리
            ------------------------------------------
            -- 사이즈2배
            local durationHeight = (LJDSpellInterruptDB["ICON_HEIGHT"]/3) * 2;    -- 아이콘 만들때 duration은 아이콘의 1/3로 만들었음.
            local iconWidth  = LJDSpellInterruptDB["ICON_WIDTH"] * 2;      -- 아이콘 2배크기 Width
            local iconHeight = LJDSpellInterruptDB["ICON_HEIGHT"] * 2;     -- 아이콘 2배크기 Height

            icon:SetSize(iconWidth+1, iconHeight);  -- 아이콘사이 공백1 감안
            icon.duration:SetTextHeight(durationHeight);
            icon.caster:SetText("");    -- 스킬시전자

            -------------------------------------------------------
            -- 프레임크기 재지정
            -- ; 추후 다른 프레임의 위치 참조용(현재는 의미없음)
            -------------------------------------------------------
            if IndexIcon == 1 then
                durationHeight = 0;                                     -- 큰아이콘은 duration을 표현안함.(cooldown으로 처리)
                self:SetSize(300, (iconHeight + 2 ) + durationHeight); -- 상하테두리감안해서 + 2

                -- 내케릭 큰버프 위치
                if UnitIsUnit("player", self.unit) then
                    -- 내 케릭은 체력바 위로(이름이 없으니..)
                    --self:SetPoint("BOTTOMLEFT", self:GetParent().UnitFrame.healthBar.border, "TOPLEFT", 0, 0 ) -- + 10
                    --self:ClearAllPoints();
                    --self:SetPoint("BOTTOM", PlayerName          , "TOP" , 0 ,5 );
                    --self:SetPoint("LEFT"  , PlayerFrameHealthBar, "LEFT", 0 ,0 );
                end
            end

            --------------------------------------------------------------------------------------------
            -- border 처리
            -- ; 아이콘 기준으로 움직이지만, 아이콘보다 back에 존재해서 Anchor 형태로 처리할수 없었다.
            --   (아이콘보다 앞으로 가져오면 아이콘은 전체적으로 붉은색으로 변함)
            --   그래서, 아이콘이 변경될때, border도 동기화 처리함.
            --------------------------------------------------------------------------------------------
            icon.border:SetSize(icon:GetWidth() + 2, icon:GetHeight() + 2);
            icon.border:SetPoint("BOTTOMLEFT", icon, "BOTTOMLEFT", -1, -1);

        end
    end;

    -- 오라가 계속 생겼다가 사라졌다가 하니, 안쓰는 아이콘은 삭제하는것보다
    -- hide 로 안보이게 해두는게 효율적이다.
    for IndexRemove = (IndexIcon+1), #self.icon do
        if( self.icon[IndexRemove] and self.icon[IndexRemove]:IsShown() ) then
            self.icon[IndexRemove]:Hide();
        end;
    end

    self.iconShownCount = IndexIcon; -- 현재보여진 아이콘수를 저장

end


function HighlightBigDeBuffFrame_Update(self, filter)

    self.filter = filter;
    local IndexIcon = 0;

    local orgFrame = self:GetParent().highlightDeBuffFrame;
    ----------------------------------------------------------------------
    -- 이미 표현된 아이콘을 검색해서 특정스킬만 (큰아이콘프레임)에 표현.
    ----------------------------------------------------------------------
    for i=1, #orgFrame.icon do
        if orgFrame.icon[i]:IsShown() then
            local auraInfo = {};
            auraInfo={UnitAura(orgFrame.icon[i].unitId, orgFrame.icon[i]:GetID(), filter)};
            --auraInfo={UnitDebuff(plateFrame.UnitFrame.unit, i)};

            local debugName={"name", "icon", "count", "dispelType", "duration", "expires", "unitCaster", "canStealOrPurge", "nameplateShowPersonal", "spellID", "canApplyAura", "isBossDebuff", "isCastByPlayer", "nameplateShowAll", "timeMod","","","","","","","",""}
            --DebugPrint(auraInfo, debugName);

            if #auraInfo == 0 then
                break;
            end

            local CheckShowBigSkil = false;

            -- 크게 표현할 아이콘목록
            --local ShowBigDebuffSkilList={"울려퍼지는 보호", "전투의 징후", "고위 천사", "공황!"}; -- 디버깅용
            local ShowBigDebuffSkilList={};

            for j=1, #ShowBigDebuffSkilList do
                if auraInfo[1] == ShowBigDebuffSkilList[j] then
                    CheckShowBigSkil = true;
                    break;
                end;
            end

            if CheckShowBigSkil then
                --print("크게 표현될 아이콘~");
                --DebugPrint(auraInfo);
                IndexIcon = IndexIcon + 1;

                local icon = GetIcon(self, IndexIcon);
                icon.texture:SetTexture(auraInfo[2]); -- 이미지를 넣어주고

                -- 쿨다운 UI 를 실행하는 함수이다.
                -- 1번째 인자로, 오라의 시작 시간 (초단위며, 시작 시간을 얻기 위해 종료시간에서 지속시간을 뺌)
                -- 2번째 인자로, 지속시간을 넣어주면 된다.
                -- 함수를 실행하는 순간! 자동으로 애니메이션과 숫자가 표시된다!
                --icon.cooldown:SetCooldown(auraInfo[6]-auraInfo[5], auraInfo[5]);
                if auraInfo[5] > 0 then
                    icon.cooldown:Show();
                    CooldownFrame_Set(icon.cooldown, auraInfo[6]-auraInfo[5], auraInfo[5], auraInfo[5]>0, true);
                else
                    icon.cooldown:Hide();
                end;

                -- 쿨다운 카운트다운 제거할지 설정변수
                icon.cooldown:SetHideCountdownNumbers(false);

                -- 버프이므로 Cooldown 상태 강조위해 반전
                icon.cooldown:SetReverse(true);

                -- BuffFrame의 카운트다운 흉내내기
                --[[
                icon.expirationTime = auraInfo[6];
                icon.timeLeft = ceil(icon.expirationTime - GetTime());
                local duration = {"%s", ""};
                if( auraInfo[5] > 0 ) then duration = {SecondsToTimeAbbrev(icon.timeLeft)}; end;
                icon.duration:SetFormattedText(unpack(duration));
                --]]

                -- 중첩이 1 이하는 표현할 필요 없으니, 2이상만 표시
                if auraInfo[3] > 1 then
                    icon.countText:SetText(auraInfo[3]);
                else
                    icon.countText:SetText(nil);
                end
                -- 아이콘에 정보를 담았으니 출력
                icon:Show();

                -- 툴팁연결을 위한 변수추가
                icon.unitId = self.unit;
                icon:SetID(i);

                icon.isStealable = auraInfo[8]; -- 마훔가능여부 저장
                
                -- 아이콘 툴팁 연결 (option 적용)
                if( LJDSpellInterruptDB["ShowSpecialBuffTooltip"] ) then
                    -- 없는 경우만 재지정한다.
                    -- OnUpdate는 별로 타이머로 구현.
                    --icon:SetScript("OnUpdate", HighlightBuffFrame_AuraOnUpdate    );
                    if( not icon:GetScript("OnEnter") ) then icon:SetScript("OnEnter" , HighlightBuffFrame_AuraOnMouseEnter); end;
                    if( not icon:GetScript("OnLeave") ) then icon:SetScript("OnLeave" , HighlightBuffFrame_AuraOnMouseLeave); end;
                    --if( not icon:GetScript("OnClick") ) then icon:SetScript("OnClick" , HighlightBuffFrame_AuraOnMouseClick); end;
                else
                    --icon:SetScript("OnUpdate", nil                                );
                    icon:SetScript("OnEnter" , nil                                );
                    icon:SetScript("OnLeave" , nil                                );
                    --icon:SetScript("OnClick" , nil                                );
                end

                ------------------------------------------
                -- 큰아이콘화 처리
                ------------------------------------------
                -- 사이즈2배
                local durationHeight = (orgFrame.icon[i]:GetHeight()/3) * 2;    -- 아이콘 만들때 duration은 아이콘의 1/3로 만들었음.
                local iconWidth  = orgFrame.icon[i]:GetWidth() * 2;      -- 아이콘 2배크기 Width
                local iconHeight = orgFrame.icon[i]:GetHeight() * 2;     -- 아이콘 2배크기 Height

                icon:SetSize(iconWidth+1, iconHeight);  -- 아이콘사이 공백1 감안
                icon.duration:SetTextHeight(durationHeight);
                icon.caster:SetText("");    -- 스킬시전자

                -------------------------------------------------------
                -- 프레임크기 재지정
                -- ; 추후 다른 프레임의 위치 참조용(현재는 의미없음)
                -------------------------------------------------------
                if IndexIcon == 1 then
                    durationHeight = 0;                                     -- 큰아이콘은 duration을 표현안함.(cooldown으로 처리)
                    self:SetSize(300, (iconHeight + 2 ) + durationHeight); -- 상하테두리감안해서 + 2

                    -- 내케릭 큰디버프 위치
                    if UnitIsUnit("player", self.unit) then
                        -- 내 케릭은 체력바 위로(이름이 없으니..)
                        --self:SetPoint("BOTTOMLEFT", self:GetParent().UnitFrame.healthBar.border, "TOPLEFT", 0, 0 ) -- + 10
                        self:ClearAllPoints();
                        self:SetPoint("TOP" , PlayerFrameManaBar  , "BOTTOM", 0 ,-5 );
                        self:SetPoint("LEFT", PlayerFrameHealthBar, "LEFT"  , 0 ,0 );
                    end

                end

                --------------------------------------------------------------------------------------------
                -- border 처리
                -- ; 아이콘 기준으로 움직이지만, 아이콘보다 back에 존재해서 Anchor 형태로 처리할수 없었다.
                --   (아이콘보다 앞으로 가져오면 아이콘은 전체적으로 붉은색으로 변함)
                --   그래서, 아이콘이 변경될때, border도 동기화 처리함.
                --------------------------------------------------------------------------------------------
                icon.border:SetSize(icon:GetWidth() + 2, icon:GetHeight() + 2);
                icon.border:SetPoint("BOTTOMLEFT", icon, "BOTTOMLEFT", -1, -1);

            end

        end
    end

    -- 오라가 계속 생겼다가 사라졌다가 하니, 안쓰는 아이콘은 삭제하는것보다
    -- hide 로 안보이게 해두는게 효율적이다.
    for IndexRemove = (IndexIcon+1), #self.icon do
        if( self.icon[IndexRemove] and self.icon[IndexRemove]:IsShown() ) then
            self.icon[IndexRemove]:Hide();
        end;
    end

    self.iconShownCount = IndexIcon; -- 현재보여진 아이콘수를 저장

end

function PlayerBigBuffFrame_Update()

    self = _G["PlayerBigBuffFrame"];
    self.filter = "HELPFUL";
    self.unit = "Player";
    local IndexIcon = 0;

    if not LJDSpellInterruptDB["ShowPlayerBigBuff"] then
        self:Hide();
    else
        self:Show();
    end

    --DebugPrint("PlayerBigBuff");
    --DebugPrint(time());

    -- 내케릭용 큰버프표시
    if not UnitIsUnit("player", self.unit) then
        return
    end

    for i= 1, BUFF_MAX_DISPLAY do

        local auraInfo = {};
        auraInfo={UnitAura(self.unit, i, filter)};
        --auraInfo={UnitDebuff(plateFrame.UnitFrame.unit, i)};

        local debugName={"name", "icon", "count", "dispelType", "duration", "expires", "unitCaster", "canStealOrPurge", "nameplateShowPersonal", "spellID", "canApplyAura", "isBossDebuff", "isCastByPlayer", "nameplateShowAll", "timeMod","","","","","","","",""}
        --DebugPrint(auraInfo, debugName);

        if #auraInfo == 0 then
            break;
        end

        --if(auraInfo[2] == nil) then print("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!") end;

        local CheckShowBigSkil = false;

        -- 크게 표현할 아이콘목록
        --local ShowBigBuffSkilList={"울려퍼지는 보호", "전투의 징후", "고위 천사", "정의의 방패"};  -- 디버깅용
        --local ShowBigBuffSkilList={"고위 천사", "불안정한 마나진주", "정의의 방패"};

        for j=1, #ShowBigBuffSkilList do
            if auraInfo[1] == ShowBigBuffSkilList[j] then
                CheckShowBigSkil = true;
                break;
            end;
        end

        if CheckShowBigSkil then
            --print("크게 표현될 아이콘~");
            --DebugPrint(auraInfo);
            IndexIcon = IndexIcon + 1;

            local icon = GetIcon(self, IndexIcon);
            icon.texture:SetTexture(auraInfo[2]); -- 이미지를 넣어주고

            -- 쿨다운 UI 를 실행하는 함수이다.
            -- 1번째 인자로, 오라의 시작 시간 (초단위며, 시작 시간을 얻기 위해 종료시간에서 지속시간을 뺌)
            -- 2번째 인자로, 지속시간을 넣어주면 된다.
            -- 함수를 실행하는 순간! 자동으로 애니메이션과 숫자가 표시된다!
            --icon.cooldown:SetCooldown(auraInfo[6]-auraInfo[5], auraInfo[5]);
            if auraInfo[5] > 0 then
                icon.cooldown:Show();
                CooldownFrame_Set(icon.cooldown, auraInfo[6]-auraInfo[5], auraInfo[5], auraInfo[5]>0, true);
            else
                icon.cooldown:Hide();
            end;

            -- 쿨다운 카운트다운 제거할지 설정변수
            icon.cooldown:SetHideCountdownNumbers(false);

            -- 버프이므로 Cooldown 상태 강조위해 반전
            icon.cooldown:SetReverse(true);

            -- BuffFrame의 카운트다운 흉내내기
            --[[
            icon.expirationTime = auraInfo[6];
            icon.timeLeft = ceil(icon.expirationTime - GetTime());
            local duration = {"%s", ""};
            if( auraInfo[5] > 0 ) then duration = {SecondsToTimeAbbrev(icon.timeLeft)}; end;
            icon.duration:SetFormattedText(unpack(duration));
            --]]

            -- 중첩이 1 이하는 표현할 필요 없으니, 2이상만 표시
            if auraInfo[3] > 1 then
                icon.countText:SetText(auraInfo[3]);
            else
                icon.countText:SetText(nil);
            end
            -- 아이콘에 정보를 담았으니 출력
            icon:Show();

            -- 툴팁연결을 위한 변수추가
            icon.unitId = self.unit;
            icon:SetID(i);

            icon.isStealable = auraInfo[8]; -- 마훔가능여부 저장
            icon.dispelType  = auraInfo[4]; -- dispelType 저장

            -- 아이콘 툴팁 연결 (option 적용)
            if( LJDSpellInterruptDB["ShowSpecialBuffTooltip"] ) then
                -- 없는 경우만 재지정한다.
                -- OnUpdate는 별로 타이머로 구현.
                --icon:SetScript("OnUpdate", HighlightBuffFrame_AuraOnUpdate    );
                if( not icon:GetScript("OnEnter") ) then icon:SetScript("OnEnter" , HighlightBuffFrame_AuraOnMouseEnter); end;
                if( not icon:GetScript("OnLeave") ) then icon:SetScript("OnLeave" , HighlightBuffFrame_AuraOnMouseLeave); end;
                --if( not icon:GetScript("OnClick") ) then icon:SetScript("OnClick" , HighlightBuffFrame_AuraOnMouseClick); end;
            else
                --icon:SetScript("OnUpdate", nil                                );
                icon:SetScript("OnEnter" , nil                                );
                icon:SetScript("OnLeave" , nil                                );
                --icon:SetScript("OnClick" , nil                                );
            end

            ------------------------------------------
            -- 큰아이콘화 처리
            ------------------------------------------
            -- 사이즈2배
            local durationHeight = (LJDSpellInterruptDB["ICON_HEIGHT"]/3) * 2;    -- 아이콘 만들때 duration은 아이콘의 1/3로 만들었음.
            local iconWidth  = LJDSpellInterruptDB["ICON_WIDTH"] * 2;      -- 아이콘 2배크기 Width
            local iconHeight = LJDSpellInterruptDB["ICON_HEIGHT"] * 2;     -- 아이콘 2배크기 Height

            icon:SetSize(iconWidth+1, iconHeight);  -- 아이콘사이 공백1 감안
            icon.duration:SetTextHeight(durationHeight);
            icon.caster:SetText("");        -- 스킬시전자

            -------------------------------------------------------
            -- 프레임크기 재지정
            -- ; 추후 다른 프레임의 위치 참조용(현재는 의미없음)
            -------------------------------------------------------
            if IndexIcon == 1 then
                durationHeight = 0;                                     -- 큰아이콘은 duration을 표현안함.(cooldown으로 처리)
                self:SetSize(300, (iconHeight + 2 ) + durationHeight); -- 상하테두리감안해서 + 2
            end

            --------------------------------------------------------------------------------------------
            -- border 처리
            -- ; 아이콘 기준으로 움직이지만, 아이콘보다 back에 존재해서 Anchor 형태로 처리할수 없었다.
            --   (아이콘보다 앞으로 가져오면 아이콘은 전체적으로 붉은색으로 변함)
            --   그래서, 아이콘이 변경될때, border도 동기화 처리함.
            --------------------------------------------------------------------------------------------
            icon.border:SetSize(icon:GetWidth() + 2, icon:GetHeight() + 2);
            icon.border:SetPoint("BOTTOMLEFT", icon, "BOTTOMLEFT", -1, -1);

        end
    end;

    -- 오라가 계속 생겼다가 사라졌다가 하니, 안쓰는 아이콘은 삭제하는것보다
    -- hide 로 안보이게 해두는게 효율적이다.
    for IndexRemove = (IndexIcon+1), #self.icon do
        if( self.icon[IndexRemove] and self.icon[IndexRemove]:IsShown() ) then
            self.icon[IndexRemove]:Hide();
        end;
    end

    self.iconShownCount = IndexIcon; -- 현재보여진 아이콘수를 저장

end

--> allow BuffContainerLayoutHook to be overridden by scripts
function LJDNameplate_Aura_update(unitFrame)

    if type(unitFrame.unit) ~= "string" then return end;

    local tName = unitFrame.unit or "NoName";
    local tUnitName = UnitName(unitFrame.unit) or "NoName";


    --if( not LJDSpellInterruptDB["ShowSpecialBuff"] ) then return end;
--if( tName ~= "nameplate3" ) then return end;


    -- 주요 확인
    --print(tName..":"..tUnitName);

    -- 호출된 인자가 UnitFrame가 아닐수 있음
    local plateFrame = C_NamePlate.GetNamePlateForUnit(unitFrame.unit)
    if (not plateFrame) then
        return
    end

    --print(unitFrame.filter);

    --print(plateFrame:GetName()..":"..plateFrame.UnitFrame.unit);

    --DebugPrintTable(plateFrame);
    if type(plateFrame.UnitFrame.unit) ~= "string" then
        print("plateFrame.UnitFrame.unit 값이 문자열이 아님["..type(plateFrame.UnitFrame.unit).."]" );
        return
    end;


if( unitFrame.unit ~= plateFrame.UnitFrame.unit ) then print( unitFrame.unit .. " 왜 다를까 " .. plateFrame.UnitFrame.unit ); end;

    if( LJDSpellInterruptDB["ShowSpecialBuff"] ) then
        plateFrame.highlightBuffFrame.unit = plateFrame.UnitFrame.unit;
        HighlightBuffFrame_Update(plateFrame.highlightBuffFrame, "HELPFUL|INCLUDE_NAME_PLATE_ONLY");    -- 버프
        plateFrame.highlightBuffFrame:Show();

        plateFrame.highlightBigBuffFrame.unit = plateFrame.UnitFrame.unit;
        HighlightBigBuffFrame_Update(plateFrame.highlightBigBuffFrame, "HELPFUL");  -- 버프(큰아이콘)
        plateFrame.highlightBigBuffFrame:Show();
    end;
    if( LJDSpellInterruptDB["ShowSpecialDeBuff"] ) then
        plateFrame.highlightDeBuffFrame.unit = plateFrame.UnitFrame.unit;
        HighlightDeBuffFrame_Update(plateFrame.highlightDeBuffFrame, "HARMFUL|INCLUDE_NAME_PLATE_ONLY");    -- 디버프
        --HighlightDeBuffFrame_Update(plateFrame.highlightDeBuffFrame, "HELPFUL|INCLUDE_NAME_PLATE_ONLY");  -- 디버프 디버깅용
        plateFrame.highlightDeBuffFrame:Show();

        plateFrame.highlightBigDeBuffFrame.unit = plateFrame.UnitFrame.unit;
        HighlightBigDeBuffFrame_Update(plateFrame.highlightBigDeBuffFrame, "HARMFUL|INCLUDE_NAME_PLATE_ONLY");  -- 디버프(큰아이콘)
        --HighlightBigDeBuffFrame_Update(plateFrame.highlightBigDeBuffFrame, "HELPFUL|INCLUDE_NAME_PLATE_ONLY");    -- 디버프(큰아이콘) 디버깅용
        plateFrame.highlightBigDeBuffFrame:Show();
    end;

    -- 인스턴스내 파티원 등 Forbidden 처리를 위해 기본 버프프레임 표시
    plateFrame.UnitFrame.BuffFrame:Show();
    if not plateFrame:IsForbidden() then
        -- 디버프 표시여부 설정에 따라 기본프레임 숨김처리
        if( LJDSpellInterruptDB["ShowSpecialBuff"] ) then
            plateFrame.UnitFrame.BuffFrame:Hide();
        end
    end;
end
--hooksecurefunc (LayoutMixin, "Layout", LJDNameplate_Aura_update);
--WorldFrame:HookScript('OnUpdate', LJDNameplate_Aura_update);
--ShouldShowBuff

-- 20201031 기본UI에서 제공하는 반쪽짜리 버프/디버프 표시기능 끄기(동일 아이콘 겹침을 피하기 위해)
-- ; 근본적으로 Mixin의 ShouldShowBuff함수를 Override하면 될것으로 시도했으나 실패
--   프레임을 만들고, NAME_PLATE_UNIT_ADDED 이벤트시 Nameplate마다 Override 시킴.
--hooksecurefunc(NameplateBuffContainerMixin, "ShouldShowBuff", function() return false; end);
local LJDShouldShowBuffOffFrame = CreateFrame("FRAME");
LJDShouldShowBuffOffFrame:SetScript('OnEvent', function(self, event, ...)
    return self[event] and self[event](self, event, ...)
end)

function LJDShouldShowBuffOffFrame:NAME_PLATE_UNIT_ADDED(...)
    local ll = {...};
    --DebugPrint(ll);
    local unitBarId = ll[2];
    local unitID = unitBarId
    
    local plateFrame = C_NamePlate.GetNamePlateForUnit (unitBarId, issecure());
    if (not plateFrame) then
        return;
    end
    
    --ShouldShowBuff override
    plateFrame.UnitFrame.BuffFrame.ShouldShowBuff = function() return false; end;
end
LJDShouldShowBuffOffFrame:RegisterEvent('NAME_PLATE_UNIT_ADDED');
    


